<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 577 $
 * $Author: PragmaMx $
 * $Date: 2022-08-26 20:06:36 +0200 (Fr, 26. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * definiert, dass diese Datei bereits includet wurde
 * nicht verändern!
 */
if (defined('PMX_FOOTER')) {
    return;
} else {
    define('PMX_FOOTER', true);
}

/* Ausgabe des Moduls etc. kann hier für Hook verwendet werden */
$content = ob_get_clean();

/* vorerst hierrüber mal schaltbar - im Modul muss dann 0(standard)/1 angegeben werden */
global $plugins;

if (pmxBase::get('plugins')==1 ) {		//or $plugins==1 
	if (MX_MODULE != "admin" ) {
		$hook = load_class('Hook', 'prepare.content');
		$hook->run($content);
	}
	/* auch noch über die Plugins laufen lassen */
		$mxp = load_class('Plugin', 'prepare.content');
		$mxp->run($content);
}

ob_start();
/* TODO : in Template auslagern */
if ($content) {
    /* eindeutige Modul css-Id drumrum */
    echo '
    <div id="pmx-content" class="mod-' . MX_MODULE . '">
    ' . $content . '
    </div>';
}

/**
 * untere Centerblöcke anzeigen, direkt unter der Ausgabe des Moduls,
 * Bei vkpMx-Themes ist diese Ausgabe im Theme definiert
 */
if (defined('MX_HOME_FILE') ) {
    //echo '<div id="pmx-content" class="blocks-down">';
     blocks('down');
	//echo '</div>';
}

/**
 * Funktion 'themefooter' aus Theme aufrufen.
 * Darin werden auch die rechten Blöcke angezeigt
 */
themefooter();

echo mxOfflineInfo();
/**
 * zusätzliche Datei für benutzerdefinierte Zusätze am Ende der HTML-Ausgabe
 */
include_once(PMX_SYSTEM_DIR . DS . 'my_footer.php');

/* Debug-Info ausgeben */
echo mxDebugInfo();
	
/**
 * den Ausgabepuffer nachbehandeln
 * Der Ausgabepuffer wurde in mainfile.php explizit gestartet!
 * falls doch leer, ist z.B. nix mit mod_rewrite
 */
if (ob_get_length()) {
    /* die HTML-Ausgabe beenden */
 

    // $xx = memory_get_usage(true) /1024  /1024 ;
    // mxDebugFuncVars($xx);
    $mxoutput = trim(ob_get_clean());
    // Das Array mit den versch. Doc-Type Deklarationen auslesen
    $doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);

    /* Lightbox aktivieren */
    if (preg_match('#rel\s*=\s*["\']pretty(Photo)?(\[[^\]]+\])?["\']#', $mxoutput)) {
        pmxHeader::add_lightbox();
    }
    
	/* eventuell fehlende URL bei media-Links eintragen */
	$mxoutput = str_replace('href="http://media', 'href="'.MX_BASE_URL.'media', $mxoutput);

	
    /* versch. Attribute korrigieren, die durch glob. Stylesheet auf 0 gesetzt werden */
    if (preg_match_all('#(hspace|vspace|cellspacing|cellpadding)\s*=\s*["\']([1-9](?:[0-9]{1,})?)#', $mxoutput, $matches)) {
        $out = array();
        foreach ($matches[2] as $key => $value) {
            switch ($matches[1][$key]) {
                case 'hspace':
                    $out[$matches[0][$key]] = '*[hspace="' . $value . '"]{margin-left:' . $value . 'px;margin-right:' . $value . 'px;}';
                    break;
                case 'vspace':
                    $out[$matches[0][$key]] = '*[vspace="' . $value . '"]{margin-bottom:' . $value . 'px;margin-top:' . $value . 'px;}';
                    break;
                case 'cellspacing':
                    $out[$matches[0][$key]] = 'table[cellspacing="' . $value . '"]{border-collapse: separate;border-spacing: ' . $value . 'px;}';
                    break;
                case 'cellpadding':
                    $out[$matches[0][$key]] = 'table[cellpadding="' . $value . '"] > tbody > tr > td,table[cellpadding="' . $value . '"] > tbody > tr > th {padding:' . $value . 'px;}';
                    break;
            }
        }
        pmxHeader::add_style_code(str_replace(' ', '', implode('', $out)));
    }

    /* Hook um den Content der ganzen Seite modular zu beeinflussen */
    /* z.B. private Nachrichten abfragen */
    $hook = load_class('Hook', 'prepare.page');
    $hook->run($mxoutput);

    /* auch noch über die Plugins laufen lassen */
    $mxp = load_class('Plugin', 'prepare.page');
    $mxp->run($mxoutput);    
    
    /* zusätzliche headertags vorher noch an die korrekte Stelle setzen */
    $mxoutput = pmxHeader::move($mxoutput);

	/* zusätzliche JS ans Ende der Contents setzen */
	$mxoutput= pmxHeader::get_body($mxoutput);
    


    
    /* mod_rewrite, Ersetzen der Links in ein suchmaschinenfreundliches Format. */
    $seo = load_class('Config', 'pmx.seo');
    if ($mxoutput && array_sum((array)$seo->modrewrite)) {
        load_class('Modrewrite', false);
        $mxoutput = pmxModrewrite::prepare($mxoutput);
    }    
    
    /* zusätzliche optionale Datei um den Ausgabepuffer zu manipulieren */
    if (file_exists(PMX_SYSTEM_DIR . DS . 'prepareoutput.php')) {
        include(PMX_SYSTEM_DIR . DS . 'prepareoutput.php');
    }

    /* den html-Output (Ausgabepuffer) ausgeben */
    echo $mxoutput;

    /* Speicher aufräumen */
    unset($mxoutput, $matches, $allstyles);
} else {
    /* falls kein Ausgabepuffer vorhanden, die zusätzlichen Header-Tags zumindest noch ans Ende schreiben... */
    echo pmxHeader::get();
    /* das Ende, der HTML-Ausgabe */
}

    /* auch noch mal über die Plugins laufen  */
    $mxp = load_class('Plugin', 'system.end');
    $mxp->run();


    echo"</body>";
    echo"</html>";

die(); 
?>
