<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 */
function mxcredit_gethtml()
{
    
    /* Sprachdatei auswaehlen */
    mxGetLangfile(PMX_LANGUAGE_DIR . DS . 'credits');
	$worker=mxcredit_worker();
    #sort($worker['leader'], SORT_STRING);
    #sort($worker['developer'], SORT_STRING);
    sort($worker['former_developer'], SORT_STRING);
    sort($worker['translator'], SORT_STRING);
    #$c_leader = implode(', ', $worker['leader']);
    $c_developer = implode(', ', $worker['developer']);
    $c_formerdeveloper = implode(', ', $worker['former_developer']);
    $c_translator = implode(', ', $worker['translator']);

    $content = '
    	<div class="credits" style="margin-bottom: 10px;">
     		<h3>' . _CREDITS_TITLE . '</h3>
     		<ul>
     			<li><strong>' . _CREDITS_TITLE_DEVELOPER . ':</strong><br />' . $c_developer . '</li>
     			<li><strong>' . _CREDITS_TITLE_FORMERDEVELOPER . ':</strong><br />' . $c_formerdeveloper . '</li>
     			<li><strong>' . _CREDITS_TITLE_TRANSLATOR . ':</strong><br />' . $c_translator . ' ' . _CREDITS_TRANSLATOR_MORE . '</li>
     		</ul>
		</div>
     <div class="credits" style="margin-bottom: 10px;">
     		<h3>pragmaMx</h3>
     		<ul>
     			<li>' . _CREDITS_INSPIRED . '</li>
     			<li>' . _CREDITS_LICENSE1 . '</li>
     			<li>' . _CREDITS_LICENSE2 . '</li>
     			<li>' . _CREDITS_MORE . '</li>
     		</ul>
     </div>
     <div class="credits" style="margin-bottom: 10px;">
     		<h3>' . _CREDITS_TITLE_GRAFICS . '</h3>
     		<ul>
     			<li><strong>' . _CREDITS_TITLE_MOSTICONS . '</strong><br />' . _CREDITS_MOSTICONS . '</li>
     			<!--<li><strong>' . _CREDITS_TITLE_ADMINICONS . '</strong><br />' . _CREDITS_ADMINICONS . '</li>-->
     			<li><strong>' . _CREDITS_TITLE_SMALLICONS . '</strong><br />' . _CREDITS_SMALLICONS . '</li>
     			<li><strong>' . _CREDITS_TITLE_FLAGS . '</strong><br />' . _CREDITS_FLAGS . '</li>
     			<!--<li><strong>' . _CREDITS_TITLE_GREENSMILIES . '</strong><br />' . _CREDITS_GREENSMILIES . '</li>-->
				<li><strong>' . _CREDITS_TITLE_AVATARS . '</strong><br />' . _CREDITS_AVATARS . '</li>
     		</ul>
     </div>
     ';
    return $content;
}

/**
 * Gibt Copyright-Informationen aus
 */
function mxcredit_getinfo()
{
    $intro = mxcredit_gethtml();
    if (!defined('DIR_mod_root')) {
        define('DIR_mod_root', 'modules'); /// fuer pragma pmx's
    }

    $module_info = '';
	$module_info .= "<hr/>";
    foreach ((array)glob('modules/*/setup.pmx.php', GLOB_NOSORT) as $filename) {
        $credits = null;
        $file = basename(dirname($filename));
        if ($filename && (MX_IS_ADMIN || mxModuleAllowed($file))) {
			if (substr(file_get_contents($filename),0,5)<>"<?php") mxDebugFuncVars($filename);
            $module_info .= mxcredit_get_setuppmx_string ($filename);
			$module_info .= "<hr/>";
        }
    }
    if ($module_info) {
        $module_info = '<h2 class="title">' . _SYSINFOMODULES . '</h2>' . $module_info;
    }
    $design_info = '';
	$design_info .= "<hr/>";
    foreach ((array)glob('themes/*/setup.pmx.php', GLOB_NOSORT) as $filename) {
        $credits = null;
        $file = basename(dirname($filename));
        if ($filename) {
            $design_info .= mxcredit_get_setuppmx_string ($filename);
			$design_info .= "<hr/>";
        }
    }
    if ($design_info) {
        $design_info = '<h2 class="title">' . _SYSINFOTHEMES . '</h2>' . $design_info;
    }

    $plugin_info = '';
    foreach ((array)glob('plugins/*/setup.pmx.php', GLOB_NOSORT) as $filename) {
        $credits = null;
        $file = basename(dirname($filename));
		if ($filename) {

			$plugin_info .= mxcredit_get_setuppmx_string ($filename);
			$plugin_info .= "<hr/>";
        }
    }
    if ($plugin_info) {
        $plugin_info = '<h2 class="title">' . mxText('_SYSPLUGININFO') . '</h2>' . $plugin_info;
    }
    $out['intro'] = $intro;
    $out['module_info'] = $module_info;
    $out['design_info'] = $design_info;
    $out['plugin_info'] = $plugin_info;
    return $out;
}

/* die Ausgabe der setup.pmx.php für Impressum aufbereiten */

function mxcredit_prepare($credit="")
{
	$outputs="";
	if (is_array($credit)) {
		mxGetLangfile(PMX_LANGUAGE_DIR . DS . 'credits');
		$credit=array_merge((mxcredit_default()),$credit);
		
		$outputs .=(!$credit['name']=="")?"<h4>".$credit['name']."</h4>":"";
		$outputs .=(!$credit['version']=="")?"<div class='version'>".mxText("_CREDIT_VERSION")." : ".$credit['version']."</div>":"";
		$outputs .=(!$credit['author']=="")?"<div class='author'>".mxText("_AUTHOR")." : ".$credit['author']."</div>":"";
		$outputs .=(!$credit['author_email']=="")?"<div class='author_email'>".mxText("_AUTHOR_EMAIL")." : ".$credit['author_email']."</div>":"";
		$outputs .=(!$credit['description']=="")?"<div class='description'>".mxText("_DESCRIPTION")." : ".$credit['description']."</div>":"";
		$outputs .=(!$credit['author_url']=="")?"<div class='author_url'>".mxText("_AUTHOR_URL")." : ".$credit['author_url']."</div>":"";
		$outputs .=(!$credit['creation_date']=="")?"<div class='creation_date'>".mxText("_CREATION_DATE")." : ".$credit['creation_date']."</div>":"";
		$outputs .=(!$credit['copyright']=="")?"<div class='copyright'>".mxText("_COPYRIGHT")." : ".$credit['copyright']."</div>":"";
		$outputs .=(!$credit['license']=="")?"<div class='license'>".mxText("_LICENSE")." : ".$credit['license']."</div>":"";
		
		
		$outputs2= "<div class='content'>".
			"<h4>".$credit['name']."</h4>".
			"<div class='version'>".mxText("_CREDIT_VERSION")." : ".$credit['version']."</div>".
			"<div class='author'>".mxText("_AUTHOR")." : ".$credit['author']."</div>".
			"<div class='author_email'>".mxText("_AUTHOR_EMAIL")." : ".$credit['author_email']."</div>".
			"<div class='author_url'>".mxText("_AUTHOR_URL")." : ".$credit['author_url']."</div>".
			"<div class='author_url'>".mxText("_CREATION_DATE")." : ".$credit['creation_date']."</div>".
			"<div class='description'>".mxText("_DESCRIPTION")." : ".$credit['description']."</div>".
			"<div class='copyright'>".mxText("_COPYRIGHT")." : ".$credit['copyright']."</div>".
			"<div class='license'>".mxText("_LICENSE")." : ".$credit['license']."</div>".
			"</div>";
		//$outputs="";
	} else {
		// aus der Funktion könnte auch nur ein String zurück kommen */
        $outputs = "<div class='content'> " . strip_tags($credit)."</div><br />";	
	}
	
    if ($outputs) {

        $outputs = preg_replace('#\s+[-_=.:~*!%]{10,}\s+#', "\n", $outputs);
        $outputs = preg_replace('/&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)/', '&amp;', $outputs);
        $outputs = preg_replace("#(\s)([a-z]+?)://([^, \n\r<]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $outputs);
        $outputs = preg_replace("#(\s)www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r<]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $outputs);
        $outputs = preg_replace("#(\s)([a-z0-9\-_.]+?)@([^, \n\r<]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $outputs);
        $outputs = nl2br(trim($outputs));
    }
    return $outputs;
}

/**
 *  mxcredit_get_setuppmx_string 
 *  
 *  läd die setup.pmx.php und werte diese aus
 *  
 *  @param [in] $filename 
 *  @return $info     aufbereiteter HTML-Text für die Informationen
 *  
 *  @details
 */
function mxcredit_get_setuppmx_string ($filename)
{
		$credit=mxcredit_load_setuppmx ($filename);
		$info="";

		$info .= '' . mxcredit_prepare($credit) . '<br />';
		
		return $info;
}


function mxcredit_load_setuppmx ($filename)
{
		$credit=mxcredit_default();
		if (file_exists($filename)) //return $credit;
		{
			$file = basename(dirname($filename));
			
			//if (!file_exists(dirname($filename).DS."core".DS."setup.pmx.php")) {
				 include($filename);
				if (is_callable($credits)){
					/* neu über anonyme function */
					$credit=$credits();
				} else {
					// alte versionen mit abfangen 
					$credit=array(
					"name"=>$file,				
					"version"=>"1",
					"creation_date"=>Date("d.m.Y", filectime($filename)),
					"description"=>$credits,
					);
					

				}
			} else {
				/* since pmx 2.8 auch über ein JSON-File im Core-Ordner */
				$credit=mxcredit_load_infopmx(dirname($filename).DS."core".DS."info.pmx.json");
		}
		$credit=array_merge((mxcredit_default()),$credit);
		$credits=NULL;
		
		return $credit;	
}


function mxcredit_load_infopmx ($filename) 
{
		if (!file_exists($filename)) return array();
		$info=array();
		/* Datei einlesen */
		$jsinfo=file_get_contents($filename);
		$infod=mxcredit_default();		
		/* wenn ok, dann json auslesen */
		if (!$jsinfo) return $info;
		/* nur wenn JSON i.o. */
		$info=json_decode($jsinfo,true);
		if ($info==NULL) return $infod;

		return array_merge($infod,$info);
		
}

/* Ausgabe zusammenstellen für allgemeinen Content*/
/**
 *  mxcredit_shortinfo 
 *  
 *  @param [in] $filename 
 *  @return 
 *  
 *  Date: 2021-04-14T20:50:55 
 *  created by : Olaf Herfurth 
 */
function mxcredit_shortinfo($filename)
{
    $credits = null;

	include($filename);
	if (is_callable($credits)){
		$credit=$credits();
		
	} else {
		$credit=$credits;
		
	}

	if (is_array($credit)) {
		
		$credit=array_merge((mxcredit_default()),$credit);
		
		$outputs= "<div class='align-center credits'>".
			"".$credit['name']." - V"
			.$credit['version']." by "
			.$credit['author']."<br />"
			.$credit['copyright']

			."</div>";
		//$outputs="";
	} else {
		
        $outputs = "<div class='align center credits'>" . strip_tags($credit)."</div>";	
	}
	
    if ($outputs) {

        $outputs = preg_replace('#\s+[-_=.:~*!%]{10,}\s+#', "\n", $outputs);
        $outputs = preg_replace('/&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)/', '&amp;', $outputs);
        $outputs = preg_replace("#(\s)([a-z]+?)://([^, \n\r<]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $outputs);
        $outputs = preg_replace("#(\s)www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r<]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $outputs);
        $outputs = preg_replace("#(\s)([a-z0-9\-_.]+?)@([^, \n\r<]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $outputs);
        $outputs = nl2br(trim($outputs));
    }
    return $outputs;
}

/**
 *  mxcredit_shortinfo 
 *  
 *  @param [in] $filename 
 *  @return 
 *  
 *  Date: 2021-04-14T20:50:55 
 *  created by : Olaf Herfurth 
 */
function mxcredit_shortinfo_string($filename)
{
    $credit = mxcredit_load_setuppmx ($filename);
	$credit=array_merge((mxcredit_default()),$credit);
	$outputs= "".
		"".$credit['name']." - V"
		.$credit['version']." by "
		.$credit['author']. " &copy; "
		.$credit['creation_date']
		."";
		

        $outputs = preg_replace('#\s+[-_=.:~*!%]{10,}\s+#', "\n", $outputs);
        $outputs = preg_replace('/&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)/', '&amp;', $outputs);
        $outputs = preg_replace("#(\s)([a-z]+?)://([^, \n\r<]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $outputs);
        $outputs = preg_replace("#(\s)www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r<]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $outputs);
        $outputs = preg_replace("#(\s)([a-z0-9\-_.]+?)@([^, \n\r<]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $outputs);
        $outputs = nl2br(trim($outputs));
    
    return $outputs;
}


/**
 * Ausgabe der Informationen des pragmaMx-Developer-Team
 * Das Entfernen der Zeilen verhindert nicht die Ausgabe,
 * zerstoert aber das Layout der Seite
 */
function mxcredit()
{
    @define('MX_MODULE', 'mxcredit');
    mxIncludeHeader();
    //OpenTable();
    echo implode('<br />', mxcredit_getinfo());
    //CloseTable();
    mxIncludeFooter();
    
}


function mxcredit_worker()
{
		
	$worker['developer'][] = 'Olaf Herfurth'; // seit 1.12
	$worker['developer'][] = 'Andreas Eichler'; // since 2.2
	$worker['developer'][] = 'Sven Hedström-Lang'; // since 2.4

	$worker['former_developer'][] = 'Thierry Roussel';
	$worker['former_developer'][] = 'Sıtkı Özkurt';

	$worker['former_developer'][] = 'Andreas Ellsel';
	$worker['former_developer'][] = 'Hajo Grunert';
	$worker['former_developer'][] = 'René Henschke';
	$worker['former_developer'][] = 'David Heidrich';
	$worker['former_developer'][] = 'Olaf Lücke';
	$worker['former_developer'][] = 'Murat Yıldız';
	$worker['former_developer'][] = 'Markus von Waechter';
	$worker['former_developer'][] = 'Marco Andreas';
	$worker['former_developer'][] = 'Frank Möhring';
	$worker['former_developer'][] = 'Siggi Braunert';
	$worker['former_developer'][] = 'Zeljko Ljepojevic';
	$worker['former_developer'][] = 'Nilay Deniz';
	$worker['former_developer'][] = 'Jörg Küsters';

	$worker['translator'][] = 'Inge Galepp';
	$worker['translator'][] = 'Thierry Roussel (' . _LANGFRENCH . ')';
	$worker['translator'][] = 'Murat Yıldız (' . _LANGTURKISH . ')';
	$worker['translator'][] = 'Sıtkı Özkurt (' . _LANGTURKISH . ')';
	$worker['translator'][] = 'Klaus Mattern';
	$worker['translator'][] = 'Christopher Peterwerth';
	$worker['translator'][] = 'Katrin Wolf';
	$worker['translator'][] = 'Kris';
	$worker['translator'][] = 'Jörg Küsters';
	#$worker['translator'][] = 'Siggi Braunert';
	#$worker['translator'][] = 'Miguel Sirna (' . _LANGSPANISH . ')';
	$worker['translator'][] = 'Frank Möhring';
	$worker['translator'][] = 'Hajo Sackmann (' . _LANGGERMAN . ')';
	$worker['translator'][] = 'Wilhelm Möllering (' . _LANGDANISH . ')';
	$worker['translator'][] = 'Mustafa Navruz (' . _LANGTURKISH . ')';
	$worker['translator'][] = 'Jörg Fiedler (' . _LANGGERMAN . ')';
	$worker['translator'][] = 'Prakash Shetty (' . _LANGENGLISH . ')';
	$worker['translator'][] = 'Jochem Schausten (' . _LANGGERMAN . ')';
	$worker['translator'][] = 'Markus Kahle (' . _LANGGERMAN . ')';
return $worker;
}

function mxcredit_default()
{
	$c=array(
	"name"=>"",
	"author"=>"",
	"author_email"=>"",
	"author_url"=>"",
	"version"=>"1",
	"creation_date"=>"",
	"description"=>"",
	"copyright"=>"",
	"license"=>"GNU",
	);
	
	return $c;
			
}

function mxcredit_is_setuppmx($filename)
{
	
}
?>