<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 604 $
 * $Author: PragmaMx $
 * $ID: 2016-06-09 10:27:55 +0200 (Do, 09. Jun 2016) $
 */
 


defined('mxMainFileLoaded') or die('access denied');

/* Modulfunktionen */



/**
 * ermittelt ob der aktuelle User die Berechtigung hat, ein Modul zu nutzen
 *
 * @param string $modulname Modulname des Modules für das die Berechtigung geprüft werden soll
 * @staticvar mixed $allmodules Statische Variable in der beim ersten Aufruf der Funktion
 * mxModuleAllowed()
 * die Berechtigungen gespeichert werden
 * @return bool Liefert das Ergebnis (true/false)
 */
function mxModuleAllowed($modulename)
{
	return pmxModules::getModuleAllowed($modulename);
}

/**
 * ermittelt ob ein Modul aktiviert ist
 *
 * @param string $modulname : Name des Modules das geprüft werden soll
 * @return bool Liefert das Ergebnis (true/false)
 */
function mxModuleActive($modulename)
{
	return pmxModules::getModuleActive($modulename);
}

/**
 * aktiviert oder deaktiviert ein Modul
 *
 * @param string $modulname : Name des Modules das geaendert werden soll
 * @return bool Liefert das Ergebnis (true/false)
 */
function mxSetModuleActive($modulename, $active = 1, $view=false)
{
	$i=pmxModules::getModuleInfo($modulename);
	if (!$i){
		pmxModules::add($modulename);
		$i=pmxModules::getModuleInfo($modulename);
	}
	$act="";
	switch ($active)
	{
		case 1:
			$act="activate";
			break;
		default:
			$act="deactivate";
			
	}
	
	pmxModules::startModuleAction($modulename,$act);
	//mxDebugFuncVars($modulename,$i==false);
	return pmxModules::setModuleStatus($i['mid'], $active, $view);
}

/**
 * Ermitteln des Modulnamens für die Startseite
 * wenn keines angegeben wurde, News als Startseite eintragen
 *
 * @static string $main Statische Variable in der der name des Startseitenmodules gespeichert
 * wird
 * @return bool Liefert den Namen des Startseitenmodules zurück
 */
function mxGetMainModuleName()
{
    return pmxModules::getMainModuleName();
}

/**
 *   mxGetModuleInfo
 *  TODO: noch nicht für Admin-Module möglich
 *  @param $module_name - Modulename
 *  @return
 *
 */
 function mxGetModuleInfo ($module_name=false)
{
	return pmxModules::getModuleInfo($module_name);
}

/**
 *  mxAddModule 
 *  
 *  @param [in] $module 
 *  @return 
 *  
 *  Date: 04/15/21
 *  created by : oherf 
 */
function mxAddModule ($module)
{
	return pmxModules::add($module);
	
}

/**
 *  startModuleAction 
 *  
 *  @param [in] $modulename 
 *  @param [in] $action     
 *  @return 
 *  
 *  Date: 04/16/21
 *  created by : oherf 
 */
function startModuleAction ($modulename,$action)
{
	return pmxModules::startModuleAction ($modulename,$action);

}

//  ********************************* deprecated functions ****************************************


/**
 *  mxCheckModule 
 *  
 *  @return 
 *  
 *  Date: 04/15/21
 *  created by : oherf 
 */
function mxCheckModule()
{
	/* wird in der Modulklasse erledigt 
	 deprecated:
	TODO:
	*/
	trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);
	return;

}

?>
