<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _CONTENT;

        case $options['type'] === 'items':

            extract($options);

            /*
            <xsd:element name="loc" type="tLoc"/>
            <xsd:element name="lastmod" type="tLastmod" minOccurs="0"/>
            <xsd:element name="changefreq" type="tChangeFreq" minOccurs="0"/>
            <xsd:element name="priority" type="tPriority" minOccurs="0"/>
            */

            $result = sql_query("SELECT pid, title, subtitle, page_header, text, page_footer, signature, UNIX_TIMESTAMP(date) AS datum
                  FROM {$prefix}_pages
                  WHERE `active` = 1
                  ORDER BY `date` DESC
                  LIMIT " . $limit);
            if ($result) {
                while ($row = sql_fetch_object($result)) {
                    $entries[] = array(/* Moduldaten */
                        'loc' => "modules.php?name=" . $module_name . "&pid=" . $row->pid,
                        'lastmod' => $row->datum,
                        'text' => $row->title . ' ' . $row->subtitle . ' ' . $row->page_header . ' ' . $row->text . ' ' . $row->page_footer . ' ' . $row->signature,
                        );
                }
            }

            $result = sql_query("SELECT DISTINCT c.cid, c.title, MAX( UNIX_TIMESTAMP(p.date) ) AS datum
                          FROM `{$prefix}_pages_categories` AS c
                          LEFT JOIN {$prefix}_pages AS p ON ( c.cid = p.cid )
                          WHERE p.cid IS NOT NULL AND `date` <= now()
                          GROUP BY c.cid
                          LIMIT " . $limit);
            if ($result) {
                while ($row = sql_fetch_object($result)) {
                    $entries[] = array(/* Moduldaten */
                        'loc' => "modules.php?name=" . $module_name . "&cid=" . $row->cid,
                        'lastmod' => $row->datum,
                        'text' => $row->title,
                        );
                }
            }
    }
}

?>