<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _ENCYCLOPEDIA;

        case $options['type'] === 'items':

            extract($options);

            /* Alben */
            $qry = "SELECT en.eid, en.title, en.description as `text`, UNIX_TIMESTAMP(MAX(te.etime)) AS `date`, SUM(te.counter) AS `views`
                FROM ${prefix}_encyclopedia as en
                  LEFT JOIN ${prefix}_encyclopedia_text AS te
                    ON te.eid = en.eid
                WHERE en.active=1
                  AND MATCH( en.title, en.description)
                    AGAINST('{$search}' IN BOOLEAN MODE)
                ORDER BY `date` DESC
                LIMIT 0," . intval($limit);
            $result = sql_query($qry);

            if ($result) {
                while ($entry = sql_fetch_assoc($result)) {
                    if (!$entry['eid']) {
                        // irgendwie gibt es da als leere Datensätze...
                        continue;
                    }
                    $entry['link'] = "modules.php?name=" . $module_name . "&amp;op=list_content&amp;eid=" . $entry['eid'];
                    $entry['moduletitle'] = _ENCYCLOPEDIA;
                    $entry['module'] = $module_name;
                    unset($entry['eid']);
                    $entries[] = $entry;
                }
            }

            $qry = "SELECT te.tid, te.title, te.text, UNIX_TIMESTAMP(te.etime) AS `date`, te.counter AS `views`
                FROM ${prefix}_encyclopedia_text as te
                  INNER JOIN ${prefix}_encyclopedia AS en
                    ON te.eid = en.eid
                WHERE en.active=1
                  AND MATCH( te.title, te.text)
                    AGAINST('{$search}' IN BOOLEAN MODE)
                ORDER BY `date` DESC
                LIMIT 0," . intval($limit);
            $result = sql_query($qry);

            if ($result) {
                while ($entry = sql_fetch_assoc($result)) {
                    if (!$entry['tid']) {
                        // leere Datensätze verhindern...
                        continue;
                    }
                    $entry['link'] = "modules.php?name=" . $module_name . "&amp;op=content&amp;tid=" . $entry['tid'];
                    $entry['moduletitle'] = _ENCYCLOPEDIA;
                    $entry['module'] = $module_name;
                    unset($entry['tid']);
                    $entries[] = $entry;
                }
            }
    }
} ;

?>