<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// FAQ
// Gross-Kleinschreibungs-Bug von nuke 5.x fixen
if (isset($tables["${prefix}_faqAnswer"])) {
    if (isset($tables["${prefix}_faqanswer"])) {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqAnswer` TO `" . RENAME_PREFIX . "${prefix}_faqAnswer`";
    } else {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqAnswer` TO `${prefix}_faqanswer`";
        $tables["${prefix}_faqanswer"] = "${prefix}_faqanswer";
    }
}
if (isset($tables["${prefix}_faqCategories"])) {
    if (isset($tables["${prefix}_faqcategories"])) {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqCategories` TO `" . RENAME_PREFIX . "${prefix}_faqCategories`";
    } else {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqCategories` TO `${prefix}_faqcategories`";
        $tables["${prefix}_faqcategories"] = "${prefix}_faqcategories";
    }
}
if (isset($tables["${prefix}_faqNew"])) {
    if (isset($tables["${prefix}_faqnew"])) {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqNew` TO `" . RENAME_PREFIX . "${prefix}_faqNew`";
    } else {
        $sqlqry[] = "RENAME TABLE `${prefix}_faqNew` TO `${prefix}_faqnew`";
        $tables["${prefix}_faqnew"] = "${prefix}_faqnew";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// FAQ Standard
if (isset($tables["${prefix}_faqanswer"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_faqanswer");
    if ($tf['id']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_faqanswer` CHANGE `id` `id` INT( 11 ) NOT NULL AUTO_INCREMENT;";
    if ($tf['id_cat']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_faqanswer` CHANGE `id_cat` `id_cat` INT( 11 ) DEFAULT NULL;";
} else {
    $sqlqry[] = "
CREATE TABLE `${prefix}_faqanswer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_cat` int(11) DEFAULT NULL,
  `question` varchar(255) DEFAULT NULL,
  `answer` text,
  PRIMARY KEY  (`id`),
  KEY `id_cat` (`id_cat`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($tables["${prefix}_faqcategories"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_faqcategories");
    if ($tf['id_cat']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_faqcategories` CHANGE `id_cat` `id_cat` INT( 11 ) NOT NULL AUTO_INCREMENT;";
    // cportal
    if (isset($tf['bodytext'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqcategories` DROP bodytext;";
    if (isset($tf['bodykeys'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqcategories` DROP bodykeys;";
} else {
    $sqlqry[] = "
CREATE TABLE `${prefix}_faqcategories` (
  `id_cat` int(11) NOT NULL auto_increment,
  `categories` varchar(255) default NULL,
  `flanguage` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id_cat`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($tables["${prefix}_faqnew"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_faqnew");
    if (!isset($tf['id_cat'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqnew` ADD `id_cat` INT( 11 ) NOT NULL default '';";

    switch (true) {
        case $tf['ip']['Type'] != 'varchar(40)':
        case $tf['faq_id']['Type'] != 'int(11)':
            $sqlqry[] = "ALTER TABLE `${prefix}_faqnew`
                CHANGE `ip` `ip` varchar(40) NOT NULL default '',
                CHANGE `faq_id` `faq_id` INT( 11 ) NOT NULL AUTO_INCREMENT
                ";
    }
} else {
    $sqlqry[] = "
CREATE TABLE `${prefix}_faqnew` (
  `faq_id` int(11) NOT NULL auto_increment,
  `question` varchar(255) default NULL,
  `date` datetime default NULL,
  `name` varchar(255) default 'Anonymous',
  `ip` varchar(40) default NULL,
  `email` varchar(255) default NULL,
  `id_cat` int(11) NOT NULL default '0',
  PRIMARY KEY  (`faq_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}
// hier bereits ausfuehren, dass Daten eingefuegt werden koennen
// // alle erstellten Queries ausfuehren
// // und Fehler / Erfolge loggen
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Indexe aktualisieren
$indexes = setupGetTableIndexes("${prefix}_faqanswer");
if (!isset($indexes['id_cat'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqanswer` ADD INDEX `id_cat` ( `id_cat` );";
if (isset($indexes['id_cat_2'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqanswer` DROP INDEX `id_cat_2` ";
if (isset($indexes['id_cat_3'])) $sqlqry[] = "ALTER TABLE `${prefix}_faqanswer` DROP INDEX `id_cat_3` ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>