<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 *
 * this file based on: Nuke Guestbook v2.0.0
 * Copyright (c) 2001 by Christopher Thorjussen (joffer@online.no), http://www.nukemodules.com
 * Nuke Guestbook is based on Advanced Guestbook 1.01 (PHP/MySQL)
 * Copyright (c) 2001 Chi Kien Uong, http://www.proxy2.de
 * Modified by Francesco Bozzotta, (webmaster@nukeitalia.com), http://www.nukeitalia.com
 * Copyright (c) 2002 by Jochem Schausten (webmaster@tp-krefeld.de), http://www.tp-krefeld.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
pmxBase::set("plugins",0);

include_once(PMX_MODULES_DIR . DS . "$module_name/include/lib.inc.php");
// / Konfiguration auslesen
$NB_setting = NB_GetSettings();
$index = $NB_setting['rightblocks'];

function NB_Head()
{
    global $module_name, $NB_setting, $textcolor2;
    $total = NB_GetTotalCount();
    $dopost = '';
    if (NB_isPostAllowed()) {
        $dopost = '<font class="content">
		<a href="modules.php?name=' . $module_name . '&amp;op=AddEntry">' . mxCreateImage("modules/$module_name/images/sign.gif", _NBSIGNGUESTBOOK, 0, 'hspace="5"') . '</a>
		<b><a href="modules.php?name=' . $module_name . '&amp;op=AddEntry">' . _NBSIGNGUESTBOOK . '</a></b></font><br />

		';
    }
    $admin = '';
    if (MX_IS_ADMIN && mxGetAdminPref('radminsuper')) {
        $admin = '<div align="left" class="tiny">
		<a href="' . adminUrl($module_name) . '">' . _NBPOSTADMINTITLE . '</a></div>
		';
    }

    OpenTable();
    echo '<div align="center" class="title">' . _NBTITLE . '</div>
	<table cellspacing="0" cellpadding="5" width="100%">
	<tr valign="top">
		<td colspan="2" align="left">' . _NBWELCOME . '</td>
		<td rowspan="2" align="right"><a href="modules.php?name=' . $module_name . '" id="nb_top" name="nb_top">' . mxCreateImage("modules/$module_name/images/logo.gif", _NBTITLE) . '</a>' . $admin . '</td>
	</tr>
	<tr>
		<td>' . $dopost . '<span class="tiny" style="white-space: nowrap;">
		' . _NBTOTALRECORDS . '&nbsp;<b>' . $total . '</b>&nbsp;&nbsp;' . _NBRECORDSPERPAGE . '&nbsp;<b>' . $NB_setting['entries_per_page'] . '</b>
		</span></td>
		<td align="center">' . NB_NaviForm() . '</td>
	</tr>
	</table>
	';
    CloseTable();
    echo '<br />
';
}

/**
 * ==================================================
 * function ShowNukeBook
 * This function is used to display the guestbook
 * with all its posts etc. This is the "main" screen
 * ==================================================
 */
function ShowNukeBook()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $prefix, $user_prefix;
    global $module_name, $NB_setting;

    $item = (isset($_REQUEST['item'])) ? intval($_REQUEST['item']) : 0;
    $total = NB_GetTotalCount();
    $thread = $total - $item;

    $qry = "SELECT G.*, G.name AS nbname, U.uid AS uid
	FROM {$prefix}_{$NB_setting['dbtable']} AS G
	LEFT JOIN {$user_prefix}_users AS U
	ON G.name = U.uname
	ORDER BY G.date DESC, G.id DESC
	LIMIT " . intval($item) . ", " . intval($NB_setting['entries_per_page']);
    $results = sql_query($qry);

    include('header.php');
    NB_Head();
    if ($total) {
        echo '
		<table width="100%" border="0" cellspacing="0" cellpadding="2">
		';
        while ($entry = sql_fetch_assoc($results)) {
            $entry['thread'] = $thread;
            $entry['item'] = $item;
            NB_ViewEntry($entry);
            $thread--;
        }
        echo '</table>
		';
        // $html_code = ($NB_setting['allow_html'] == 1) ? _NBHTMLENABLED : _NBHTMLDISABLED;
        // echo '<center><div class="tiny">' . mxCreateImage('modules/'.$module_name.'/images/point2.gif', '', 0, 'width="9" height="9"') . $html_code.'</div></center>';
        $next_item = $item + $NB_setting['entries_per_page'];
        $prev_item = $item - $NB_setting['entries_per_page'];
        $navigation = '';
        if ($prev_item >= 0) {
            $navigation .= '<span class="content">
				<a href="modules.php?name=' . $module_name . '&amp;item=' . $prev_item . '">' . mxCreateImage(PMX_IMAGE_PATH . 'previous.png', _NBPREVPAGE, 0, 'style="margin: 0 .5em"') . _NBPREVPAGE . '</a>
				</span>';
        }
        if ($prev_item >= 0 && $next_item < $total) {
            $navigation .= '&nbsp;&nbsp;';
        }
        if ($next_item < $total) {
            $navigation .= '<span class="content">
				<a href="modules.php?name=' . $module_name . '&amp;item=' . $next_item . '">' . _NBNEXTPAGE . mxCreateImage(PMX_IMAGE_PATH . 'next.png', _NBNEXTPAGE, 0, 'style="margin: 0 .5em"') . '</a>
				</span>
				';
        }
        if ($navigation) {
            OpenTable();
            echo '<center><div class="content">' . $navigation . '</div></center>';
            CloseTable();
        }
    }
    include('footer.php');
}

/**
 * ==================================================
 * function AddEntry
 * This function displays the form for the user to
 * sign the guestbook
 * ==================================================
 */
function AddEntry()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name, $NB_setting;

    if (!NB_isPostAllowed()) {
        gb_error(_NBREGONLY);
    }

    $entry = array();
    if (MX_IS_USER) {
        $userinfo = mxGetUserData();
        $entry['uid'] = $userinfo['uid'];
        $entry['nbname'] = $userinfo['uname'];
        $entry['url'] = $userinfo['url'];
        $entry['nukeuser'] = 1;
    } else {
        $entry['uid'] = 0;
        $entry['nbname'] = '';
        $entry['nukeuser'] = 0;
    }

    include('header.php');
    NB_Head();
    NB_SubmitForm($entry, _NBADDENTRY);
    include('footer.php');
}

/**
 * ==================================================
 * function PreviewEntry
 * Funciton to display a preview of the information
 * the user has written. Gives the user the option
 * to submit or go back and correct
 * ==================================================
 */
function PreviewEntry()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name, $NB_setting;

    if (!NB_isPostAllowed()) {
        gb_error(_NBREGONLY);
    }

    $entry = NB_CheckEntry(mxStripSlashes($_POST));
    // Immer die IP speichern, siehe Bug-ID 933
    // $entry['host'] = @gethostbyaddr (MX_REMOTE_ADDR);
    $entry['host'] = MX_REMOTE_ADDR;
    $entry['date'] = time();
    $entry['id'] = 1;

    include('header.php');
    NB_Head();
    echo '
	<table width="100%" border="0" cellspacing="0" cellpadding="2">
	<tr><td colspan="2" class="bgcolor2">
	<font class="content"><b>' . _NBPREVIEW . '</b></font><br />

	<font class="tiny">' . _NBGUESTBOOKENTRY . '</font>
	</td></tr>
	';
    NB_ViewEntry($entry);
    echo '</table>
	';
    NB_SubmitForm($entry, _NBADDENTRY);
    include('footer.php');
}

/**
 * ==================================================
 * function SubmitPost
 * This function inserts the guestbook entry into
 * the database, but first it checks for special
 * characters and format, such as HTML code & NBCode
 * ==================================================
 */
function SubmitPost()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name, $NB_setting, $prefix;

    if (!NB_isPostAllowed()) {
        gb_error(_NBREGONLY);
    }

    $captcha_object = load_class('Captcha', 'guestbookon');
    if (!$captcha_object->check($_POST, 'captcha')) {
        gb_error(_CAPTCHAWRONG, $_POST);
    }

    $entry = NB_CheckEntry($_POST);
    // Immer die IP speichern, siehe Bug-ID 933
    // $host = @gethostbyaddr (MX_REMOTE_ADDR);
    $host = MX_REMOTE_ADDR;
    $time = time();
    $table = ($NB_setting['confirmation']) ? "{$prefix}_{$NB_setting['dbtable']}_queue" : "{$prefix}_{$NB_setting['dbtable']}";
    $checkdate = time() - intval($NB_setting['waitseconds']);

    $result = sql_query("SELECT id FROM ${table} where date >= " . $checkdate . " AND (host = '" . mxAddSlashesForSQL($host) . "' OR name = '" . mxAddSlashesForSQL($entry['nbname']) . "')");
    if (sql_num_rows($result)) {
        gb_error(_NBWAITTOPOST);
        die();
    }

    $result = sql_query("INSERT INTO {$table} (name,email,url,date,host,comment,nukeuser) VALUES ('" . mxAddSlashesForSQL($entry['nbname']) . "','" . mxAddSlashesForSQL($entry['email']) . "','" . mxAddSlashesForSQL($entry['url']) . "','" . $time . "','" . mxAddSlashesForSQL($host) . "','" . mxAddSlashesForSQL($entry['comment']) . "','" . intval(MX_IS_USER) . "')");

    if ($result) {
        $msg = ($NB_setting['confirmation'] == 1) ? _NBCONFIRMTXT : _NBTHANKYOU;
        if (!empty($NB_setting['gbnotify'])) {
            $link = PMX_HOME_URL . (($NB_setting['confirmation']) ? '/' . adminUrl($module_name) : '/modules.php?name=' . $module_name . '&item=0');
            $website = (empty($NB_setting['showurl'])) ? '' : "\nwebsite: " . $entry['url'];
            $notify_message = ("-- " . _NBGUESTBOOK . " --\n" . $GLOBALS['notify_message'] . "\n\n========================================================\n" . $link . "\n\nat: " . mx_strftime(_SHORTDATESTRING . ' H:i', $time) . "\nip/host:" . $host . "\nfrom: " . $entry['nbname'] . "\nmail: " . $entry['email'] . $website . "\nentry:\n" . $entry['comment'] . "");
            mxMail($GLOBALS['notify_email'], $GLOBALS['notify_subject'] . ' (' . _NBGUESTBOOK . ')', $notify_message, $GLOBALS['notify_from']);
        }
        mxRedirect('modules.php?name=' . $module_name , $msg, 2);
        return;
    } else {
        include('header.php');
        title(_NBTITLE);
        OpenTable();
        echo '<font class="content">' . _ERRNOSAVED . '</font>';
        CloseTable();
        include('footer.php');
        return;
    }
}

/**
 * ==================================================
 * function gb_error
 * Error Display function. This outputs a nice
 * error message, displaying what's wrong with the
 * users input (eg. no name or message)
 * ==================================================
 */
function gb_error($nberror, $entry = array())
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name;

    include('header.php');
    NB_Head();
    OpenTableAl();
    echo '<br /><div class="title">' . _NBERRORTITLE . '</div><br /><div class="content">' . $nberror . '</div><br />';
    CloseTableAl();
    if (is_array($entry) && count($entry)) {
        echo '<br />';
        NB_SubmitForm($entry, _NBADDENTRY);
    }
    include('footer.php');
    exit;
}

/**
 * ==================================================
 * Switch case - decide what to do based on
 * $op (short for module op)
 * ==================================================
 */

if (empty($op)) $op = '';
switch ($op) {
    case "AddEntry":
        $pagetitle = _NBTITLE . ', ' . _NBADDENTRY;
        AddEntry();
        break;

    case _NBPREVIEW:
        $pagetitle = _NBTITLE . ', ' . _NBADDENTRY;
        PreviewEntry();
        break;

    case _NBSUBMIT:
        $pagetitle = _NBTITLE . ', ' . _NBADDENTRY;
        SubmitPost();
        break;

    default:
        $pagetitle = _NBTITLE;
        ShowNukeBook();
        break;
}

?>