<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 623 $
 * $Author: PragmaMx $
 * $Date: 2022-09-15 15:24:52 +0200 (Do, 15. Sep 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
global $prefix, $blockid;
/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile(dirname(__DIR__));

class adminBlock {

	private $_config=array();
	private $_block=array();
	private $_settings=array();
	
	function __construct ($bid) 
	{
		global $bid;
		$this->_config['bid']=$bid;
		$this->_block=mxGetBlock($bid);
		$this->main();
	}

	function main ()
	{
		
		$module_name=basename(dirname(dirname(__FILE__)));
		
		$tb=load_class("AdminForm","adminblock");   
		
		$msg=FALSE;
		$redirect=false;
		switch(pmxAdminform::CheckButton())
		{
			case "save":
				$redirect=true;
			case "accept":
				$config=$_POST['config'];
				if ($config['cats'][0]==-1) $config['cats']=array(-1);
				//$this->_SetBlockConfig($this->_config['bid'],$config);
				mxSetBlockConfig($this->_config['bid'],$config);
				if ($redirect) mxRedirect(adminUrl("blocks"));
				
				$msg=mxText("_CHANGESAREOK");

				break;

			case "back":
				mxRedirect(adminUrl("blocks"));
				break;
			default:

				break;  
		}

		$this->_block = mxGetBlock($this->_config['bid']);
		$this->_settings = $this->_SetDefault($this->_block['config']);

		pmxHeader::add_jquery();
		pmxHeader::add_script_code("
			$(document).ready(function () {
            		$('#a5546425').css('display', 'block');
            		$('#a5546425').fadeOut(6000);
			});
			"	
		);		
		
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('title', mxText("_BLOCK") ." - ". mxText("_SETTINGS")."" );
		$tb->__set('acceptbutton', true);
		
		$tb->addToolbar("save");	
		$tb->addToolbar("accept");	
		//$tb->addToolbarLink("preview","admin.php?op=blocks/show&bid=".$this->_config['bid']);	
		// https://development.tecmu.de/admin.php?op=blocks/show&bid=22
		$tb->addToolbarLink("back","admin.php?op=blocks");

		$config = $this->_settings;
		if ($msg) $tb->__set("tb_text","<div id='a5546425' class='info'>".$msg."</div>");
		
		$tb->addFieldset("blocks",mxText("_BLOCK") . ":  ". $this->_block['title'] . " (".str_replace(".php","",$this->_block['blockfile']).")");
		$tb->add("blocks","number","config[newsperiod]",$config['newsperiod'],mxText("_NEWS_NEWSCOUNT"),mxText("_NEWS_NEWSCOUNT_INFO"),6,array("step"=>1,"max"=>1000,"min"=>0));
		$tb->add("blocks","number","config[storynum]",$config['storynum'],mxText("_NEWS_STORYNUM"),"",3,array("step"=>1,"max"=>100,"min"=>1));

		$tb->add("blocks","number","config[storyfirstnum]",$config['storyfirstnum'],mxText("_NEWS_STORYFIRSTNUM"),mxText("_NEWS_STORYFIRSTNUM_INFO"),3,array("step"=>1,"max"=>10,"min"=>0));
		$tb->add("blocks","number","config[showcolumns]",$config['showcolumns'],mxText("_NEWS_SHOWCOLUMNS"),"",2,array("step"=>1,"max"=>10,"min"=>0));
		$tb->add("blocks","number","config[textlen]",$config['textlen'],mxText("_NEWS_TEXTLEN"),mxText("_NEWS_TEXTLEN_INFO"),6,array("step"=>50,"max"=>1000,"min"=>0));
		$tb->add("blocks","yesno","config[showpics]",$config['showpics'],mxText("_NEWS_SHOWPICS"),"");
		$tb->add("blocks","yesno","config[showpicsfirstonly]",$config['showpicsfirstonly'],mxText("_NEWS_SHOWPICSFIRST_ONLY"),"");
		$tb->add("blocks","yesno","config[showbuttons]",$config['showbuttons'],mxText("_NEWS_SHOWBUTTONS"),"");
		$tb->add("blocks","yesno","config[showcombutton]",$config['showcombutton'],mxText("_NEWS_SHOWCOMBUTTON"),mxText("_NEWS_SHOWCOMBUTTON_INFO"));
		$tb->add("blocks","yesno","config[showdate]",$config['showdate'],mxText("_NEWS_SHOWDATE"),"");
		$tb->add("blocks","yesno","config[shownewpic]",$config['shownewpic'],mxText("_NEWS_SHOWNEWPICS"),"");
		$tb->add("blocks","yesno","config[showcattitle]",$config['showcattitle'],mxText("_NEWS_SHOWCATTITLE"),"");
		$tb->add("blocks","yesno","config[showextendedlinks]",$config['showextendedlinks'],mxText("_NEWS_SHOWEXTENDEDLINKS"),"");
		$tb->add("blocks","select","config[positionextendedlinks]",$config['positionextendedlinks'],mxText("_NEWS_POSITIONEXTENDEDLINKS"),mxText("_NEWS_POSITIONEXTENDEDLINKS_INFO"),1,array(_UP=>1,_DOWN=>0,_ALL=>2));
		$cats=$this->_getCategories();
		//$config
		$tb->add("blocks","select","config[cats][]",$config['cats'],mxText("_ARTICLETOCATEGORY"),mxText(""),5,$cats,"multiple=multiple");
		$tb->add("blocks","number","config[newsdays]",$config['newsdays'],mxText("_NEWS_NEWSCOUNT"),mxText("_NEWS_NEWSCOUNT_INFO"),5,array("step"=>1,"max"=>1000,"min"=>0));
		$tb->add("blocks","input","config[extcss]",$config['extcss'],mxText("_NEWS_EXTCSS"),mxText("_NEWS_EXTCSS_INFO"),30);
		
	  	/* formular abrufen */
		$form = $tb->Show();
		
		
		/* zusatzinfos abrufen */


		echo $form;
		
		/* Blockvorschau */
		
		$block = mxGetBlockData($this->_block, true);
		//mxDebugFuncVars($this->_block);
		echo '<p>'. _BLOCKPREVIEW .'&nbsp;&nbsp;<b>'. $this->_block['title'] .'&nbsp;('. $this->_block['blockfile'] .')&nbsp;</b>:</p><br /><div class="box">';
		render_blocks($block,true) ;
		echo '	</div><br />';
	}


	private function _SetDefault($config)
	{
		$default = array(
			"newsperiod"=>0,
			"storyfirstnum"=>0,
			"showcolumns"=>2,
			"storynum"=>10,
			"textlen"=>200,
			"showpics"=>true,
			"ahowpicsfirstonly"=>True,
			"showbuttons"=>true,
			"showcombutton"=>0,
			"showdate"=>true,
			"showcattitle"=>1,
			"showextendedlinks"=>1,
			"positionextendedlinks"=>0,
			"shownewpic"=>1,
			"cats"=>array(_ALL=>-1,_NOTCATEGORIZED=>0),
			"newsdays"=>10,
			"showpicsfirstonly"=>0,
			"extcss"=>"",
		);
		$config=array_merge($default,$config);
		return $config;
	}

	private function _getCategories()
	{
		$cats=array(_ALL=>-1,_NOTCATEGORIZED=>0);
		$qry = "SELECT catid, title FROM ".pmxBase::prefix()."_stories_cat ";
		$result = sql_query($qry);
		while (list($id,$name)=sql_fetch_row($result)) {
		   $cats[$name]=$id;
		}
		return $cats;
	}

}
global $bid,$blockfile;

//mxDebugFuncVars($bid,$blockfile,$op);

$op=(!isset($op))?"":$op;
$bid=(!isset($bid))?NULL:$bid;
$tmp = new adminBlock($bid);
unset ($tmp);




?>