<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 587 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 22:28:42 +0200 (Mo, 29. Aug 2022) $
 *
 * this file based on:
 * PHP-NUKE-Addon Newsletter 1.40
 * Copyright (c) by Andreas Guenther, 26.08.2001
 * webmaster@bariba.de / http://www.bariba.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminnewsletter')) {
    return mxErrorScreen(_NL_ACCESSDENIED);
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);
// mxSessionSetVar('panel', MX_ADMINPANEL_ADDON);
require_once(PMX_MODULES_DIR . DS . $module_name . DS . 'includes' . DS . 'settings.php');
require_once(PMX_MODULES_DIR . DS . $module_name . DS . 'includes' . DS . 'functions.php');

$pagetitle = _NL_ADMINTITLE;

define("_new_htmlseperator", "\n<br /><hr /><br />\n");
define("_new_textseperator", "\n\n" . str_repeat('-', intval($nl_config['wrap'] / 3 * 2)) . "\n\n");

function letter_adminpage($content)
{
    global $prefix, $adminmail, $module_name;
    // TODO: !!!!!!!!!!!!!!!
    $pagetitle = _NL_ADMINTITLE;

    $links = array(/* Navigation */
        adminUrl(PMX_MODULE) => _NL_SENDLETTER,
        adminUrl(PMX_MODULE, 'list_subscribers') => _NL_VIEWLINK,
        adminUrl(PMX_MODULE, 'list_letters') => _NL_VIEWOLD,
        adminUrl(PMX_MODULE, 'doi') => _NL_DOI,
        adminUrl(PMX_MODULE, 'doi_list') => _NL_DOILIST,
        );

    $query = "SELECT * FROM {$prefix}_newsletter WHERE status='2'";
    $result = sql_query($query);
    $subscribers = sql_num_rows($result);

    /* modulspezifisches Stylesheet einbinden */
    pmxHeader::add_style(PMX_MODULES_PATH . $module_name . '/style/style.css');

    include_once('header.php');
   // GraphicAdmin();
    OpenTable();

    ?>
<h2><?php echo _NL_ADMINTITLE ?></h2>

<div id="letteroutput">

  <div class="letmenu box">
    <p class="tiny"><?php echo _NL_COUNTABO, ': ', $subscribers, ' ', _NL_ABO ?></p>
    <ul class="list">
    <?php foreach ($links as $link => $caption) : ?>
      <li><a href="<?php echo $link ?>"><?php echo $caption ?></a></li>
    <?php endforeach ?>
    </ul>
    <br /><br />
  </div>

  <div class="letcontent">
  <?php echo $content ?>
  </div>

</div>

<?php
    CloseTable();
    include_once('footer.php');
}

/**
 * This is for you... Writing the Newsletter
 */
function letter_admin($data = array(), $errors = array())
{
    global $prefix, $adminmail, $nl_config;
    // Double-Opt-In Check
    _letter_doi_clean();

    /* Standardwerte */
    $data = array_merge(_get_letter_defaults(), $data);

    /* Artikel */
    $stories = array();
    $query = "SELECT sid, title
                  FROM {$prefix}_stories
                  WHERE `time` <= now()
                  ORDER BY `time` DESC
                  LIMIT " . intval($nl_config['maxstories']);
    $result = sql_query($query);
    while (list($sid, $title) = sql_fetch_row($result)) {
        $stories[$sid] = $title;
    }
    $storytypes = array(/* wie den Artikel anhängen */
        0 => _NL_NONE,
        1 => _NL_LINKONLY,
        2 => _NL_HOMEANDLINK,
        3 => _NL_FULLSTORY,
        );

    /* Add Banner */
	
    $banners = false;
		$hook = load_class('Hook', 'viewbanner');
		$hook->set("pos",0);
		$banners2= $hook->get(array());
	if (is_array($banners2)) {
		$banners=array();
		foreach($banners2 as $banner) {
			if ($banner['imageurl']) {
				$banners[$banner['bid']] = mxCreateImage(htmlspecialchars($banner['imageurl']), $banner['alttext'], array('title' => $banner['alttext'], 'height' => 40, 'align' => 'middle'));
			}
		}
	}
    ob_start();

    if ($errors) {

        ?>
            <div class="warning error">
              <ul><li><?php echo implode('</li><li>', $errors) ?></li></ul>
            </div>
            <?php
    }

    echo "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE, 'send') . "\">\n";
    echo '<h3>' . _NL_SENDLETTER . '</h3>';
    echo _NL_LETTERSUBJECT;
    echo "<br />";
    cgiText("subject", $data['subject'], 50, 100);
    echo "<br /><br />";
    echo _NL_LETTERTEXT;
    echo "<br />";
    cgiTextArea("text", 20, 60, $data['text']);
    echo "<br /><br />";
    echo _NL_LETTERTEXTHTML;
    echo "<br /><br />";
    cgiTextArea("html", 20, 60, $data['html']);
    echo "<br /><br />";
    echo _NL_ALTERNATESENDER;
    echo "<br />";
    cgiText("absender", $data['sender'], 50, 100);
    echo "<br /><br />";
    // Add Story
    if ($stories) {
        echo _NL_ATTACHSTORY;
        echo "<br />";
        cgiSelect("sid", "multiple", 1);
        foreach ($stories as $sid => $title) {
            cgiOption($sid, $title, $data['sid']);
        }
        cgiSelect();
        echo "<br /><br />";
        echo _NL_ATTACHTYPE;
        echo "<br />";
        cgiSelect("sidtype");
        foreach ($storytypes as $value => $caption) {
            cgiOption($value, $caption, $data['sidtype']);
        }
        cgiSelect();
        echo "<br /><br />";
        echo "<input type=\"hidden\" name=\"separator_sid\" value=\"0\" />";
        echo "<input type=\"checkbox\" name=\"separator_sid\" value=\"1\"" . (($data['separator_sid']) ? ' checked="checked"' : '') . " />\n";
        echo _NL_ADDSEPERATOR;
        echo "<br /><br />";
    }
    // Add Banner
    if ($banners) {
        echo _NL_BANNERADD;
        echo "<br />";
        echo "<input type=\"hidden\" name=\"bid[]\" value=\"0\" />";
        foreach ($banners as $bid => $image) {
            echo '<input type="checkbox" name="bid[]" value="' . $bid . '"' . ((in_array($bid, $data['bid'])) ? ' checked="checked"' : '') . ' /> ' . $image . '<br /><br />';
        }
        echo "<br /><br />";
        echo "<input type=\"hidden\" name=\"separator_bid\" value=\"0\" />";
        echo "<input type=\"checkbox\" name=\"separator_bid\" value=\"1\"" . (($data['separator_bid']) ? ' checked="checked"' : '') . " />\n";
        echo _NL_ADDSEPERATOR;
        echo "<br /><br />";
    }

    echo "<div align=\"center\">\n";
    echo "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/send\" />\n";
    echo "<input type=\"submit\" name=\"save\" value=\"" . _NL_SENDIT . "\" />\n";
    echo "</div>\n";
    echo "<br /><br />";
    echo "</form>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

/**
 * This actualy sends the mails
 */
function letter_send()
{
    global $module_name, $prefix, $adminmail;

    /* Standardwerte */
    $data = _get_letter_defaults();

    $errors = array();

    if ($_POST) {
        $_POST = mxStripSlashes($_POST);
        $data = array_merge($data, $_POST);
    }

    if (!$data['sender']) {
        $data['sender'] = $adminmail;
    }

    if (!mxCheckEmail($data['sender'])) {
        $errors[] = sprintf(_NL_ERR_ALTERNATEMAIL, $data['sender']);
        if ($data['sender'] == $adminmail) {
            $errors[] = _NL_ERR_ADMINMAIL;
        }
    }

    if (pmx_is_mail_banned($data['sender'])) {
        $errors[] = sprintf(_NL_ERR_ALTERNATEMAIL, $data['sender']) . ' (' . _MAILISBLOCKED . ')';
        if ($data['sender'] == $adminmail) {
            $errors[] = _NL_ERR_ADMINMAIL;
        }
    }

    if (!$data['text'] && !$data['html']) {
        $errors[] = _NL_ERR_NOCONTENT;
    }

    $data['subject'] = strip_tags(mxHtmlEntityDecode($data['subject']));
    if (empty($data['subject'])) {
        $errors[] = _NL_ERR_NOSUBJECT;
    }

    switch (true) {
        // case isset($_POST['preview']):
        case isset($_POST['save']) && $errors:
            return letter_admin($data, $errors);

        case !isset($_POST['save']):
        case $errors:
            return mxRedirect(adminUrl(PMX_MODULE));
    }

    extract($data, EXTR_OVERWRITE);

    if (!$html) {
        $html = mxNL2BR($text);
    }
    if (!$text) {
        $text = _letter_br2nl($html);
    }

    if ($separator_sid) {
        $text .= _new_textseperator;
        $html .= _new_htmlseperator;
    }

    if (!empty($sid) && is_array($sid)) {
        foreach ($sid as $storyid) {
            $storyid = intval($storyid);
            if ($storyid != 0) {
                $query = "SELECT sid, title, hometext, bodytext
                          FROM {$prefix}_stories
                          WHERE sid='$storyid' AND title<>''";
                $result = sql_query($query);
                list($sid, $title, $hometext, $bodytext) = sql_fetch_row($result);
                if (!$title) {
                    $sidtype = '0';
                }
                switch ($sidtype) {
                    case '0' : // Send nothing
                        break;

                    case '1' : // Send link only
                        $text = $text . "\n" . $title . "\n\n\n" . _NL_LINKTEXT . "\n" . PMX_HOME_URL . "/modules.php?name=News&file=article&sid=" . $sid;
                        $html .= "<br /><br /><a href=\"" . PMX_HOME_URL . "/modules.php?name=News&amp;file=article&amp;sid=" . $sid . "\">" . $title . "</a><br />";
                        break;

                    case '2' : // Send hometext and link
                        $text = $text . "\n\n\n" . $title . "\n" . $hometext . "\n\n" . _NL_LINKTEXT . "\n" . PMX_HOME_URL . "/modules.php?name=News&file=article&sid=" . $sid;
                        $html .= '<br /><br />' . $title . '<br /><br />' . $hometext . "<br /><br /><a href=\"" . PMX_HOME_URL . "/modules.php?name=News&amp;file=article&amp;sid=" . $sid . "\">" . _NL_LINKTEXT . "</a><br />";
                        break;

                    case '3' : // Send full Story
                        $text = $text . "\n\n\n" . $title . "\n" . $hometext . "\n" . $bodytext . "\n\n" . _NL_LINKTEXT . "\n" . PMX_HOME_URL . "/modules.php?name=News&file=article&sid=" . $sid;
                        $html .= '<br /><br />' . $title . '<br /><br />' . $hometext . '<br />' . $bodytext . "<br /><br /><a href=\"" . PMX_HOME_URL . "/modules.php?name=News&amp;file=article&amp;sid=" . $sid . "\">" . _NL_LINKTEXT . "</a><br />";
                        break;
                }
                if ($separator_sid == '1') {
                    $text .= _new_textseperator;
                    $html .= _new_htmlseperator;
                }
            }
        }
    }

    /* Converting Relative to Absolute links
     * - http://wintermute.com.au/bits/2005-09/php-relative-absolute-links/
     */
    $html = preg_replace('#(href|src)="([^:"]*)(?:")#', '$1="' . PMX_HOME_URL . '/' . '$2"', $html);

    if (!empty($bid) && is_array($bid)) {
        foreach ($bid as $bannerid) {
            $bannerid = intval($bannerid);
            if ($bannerid != 0) {
                $query = "SELECT bid, imageurl, clickurl
                          FROM {$prefix}_banner
                          WHERE bid='$bannerid'";
                $result = sql_query($query);
                list($bid, $imageurl, $clickurl) = sql_fetch_row($result);
                $text = $text . "\n\n" . _NL_BANNERTEXT . "\n" . $clickurl;
                $html = $html . '<br /><br /><a href="' . $clickurl . '">' . mxCreateImage($imageurl) . '</a><br />';
                if ($separator_bid == '1') {
                    $text .= _new_textseperator;
                    $html .= _new_htmlseperator;
                }
            }
        }
    }

    $qry = "INSERT INTO {$prefix}_newsletter_send SET
                subject='" . mxAddSlashesForSQL($subject) . "',
                text='" . mxAddSlashesForSQL($text) . "',
                html='" . mxAddSlashesForSQL($html) . "',
                send=NOW()";
    sql_query($qry);
    $newsletterid = sql_insert_id();
    $qry = "SELECT email, html, id, status, regdate
			      FROM {$prefix}_newsletter
			      WHERE status=2;";
    $i = 0;
    $result = sql_query($qry);
    while ($newsletter[$i] = sql_fetch_assoc($result)) {
        $i++;
    }
    $result_set = array();
    if (empty($subject)) {
        $subject = "Newsletter-$newsletterid";
    }

    $count = 0;
    // only send if subscriber found
    if ($newsletter) {
        @ini_set("max_execution_time", "300");
        mxBulkMail(1);
        foreach($newsletter as $recipient) {
            if (empty($recipient['email'])) {
                break;
            }
            // alte Form:
            // $buildlink = PMX_HOME_URL . '/modules.php?name=' . $module_name . '&func=action&email=' . $recipient['email'] . '&new_sub=unsub';
            // neue Form:
            $unsubid = $recipient['id'] . '.' . _letter_get_crc($recipient['email']);
            $buildlink = PMX_HOME_URL . '/modules.php?name=' . $module_name . '&unsubscribe=' . $unsubid;

            $subject = strip_tags($subject);
            // Sende Mail
            if ($recipient['html'] != 1) {
                $sendtext = $text . "\n" . _new_textseperator . _NL_INFOTEXT . "\n\t" . $GLOBALS['sitename'] . " (" . PMX_HOME_URL . ")\n\n" . _NL_INFOUNSUB . $buildlink;
                $msg = $sendtext;
                if (mxMail($recipient['email'], $subject, $msg, $absender, "text", "Newsletter-$newsletterid", "", 120)) $count++;
            } else {
                $buildlink = mx_urltohtml($buildlink);
                $htmlsendtext = mxNL2BR($html) . '<br />' . _new_htmlseperator . _NL_INFOTEXT . "\n<br /><br />\t" . $GLOBALS['sitename'] . " (<a href=\"" . PMX_HOME_URL . "\">" . PMX_HOME_URL . "</a>)<br /><br />" . _NL_INFOUNSUB . "<br /><a href=\"$buildlink\">$buildlink</a><br />";
                $msg = $htmlsendtext;
                if (mxMail($recipient['email'], $subject, $msg, $absender, "html", "Newsletter-$newsletterid", "", 120)) $count++;
            }
            $result_set[] = $recipient['id'];
        }
        mxBulkMail(0);
        @ini_restore("max_execution_time");
    }
    // schreibe Kontrolltabelle
    // only write if mail was send
    if (count($result_set)>0)
        foreach($result_set as $hast_send) {
        if (empty($hast_send)) {
            break;
        }

        $qry = "INSERT INTO {$prefix}_newsletter_sendto SET
                    userid='" . $hast_send . "',
                    newsletterid='$newsletterid',
                    date=NOW()";
        sql_query($qry);
    }

    ob_start();
    echo "<div class=\"important\"><b>" . $count . "</b> " . _NL_OK . '</div>';
    echo "<br /><br /><br />";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

/**
 * Shows the text of the Newsletter
 */
function letter_show_letter()
{
    global $prefix;

    $id = (empty($_GET['id'])) ? 0 : intval($_GET['id']);

    $query = "SELECT subject, text, html, send
              FROM {$prefix}_newsletter_send
              WHERE id='$id'";
    $result = sql_query($query);

    ob_start();
    echo "<h3>" . _NL_VIEWLETTER . "</h3>";
    if (list($subject, $text, $html, $date) = sql_fetch_row($result)) {
        echo $date;
        echo "<br /><br />";
        echo "<b>" . _NL_LETTERSUBJECT . "&nbsp;" . $subject . "</b>\n";
        echo "<br /><br /><br />";
        echo mxNL2BR($text);
        echo "<br /><br />";
        echo $html;
    } else {
        echo _NL_NOTEXTTOPRINT;
    }
    echo "<br /><br />";
    echo "<div align=\"center\">\n";
    echo "</div>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

/**
 * Prints a list of subscribers
 */
function letter_list_subscribers()
{
    global $prefix, $nl_config;

    $counter = (empty($_GET['counter'])) ? 0 : intval($_GET['counter']);

    $query = "SELECT COUNT(id)
              FROM {$prefix}_newsletter
              WHERE status=2";
    $result = sql_query($query);
    list($count_rows) = sql_fetch_row($result);

    $query = "SELECT t1.email, t1.status, t1.id, t1.html, t1.regdate, t1.regip, t2.userid, count(*)
              FROM {$prefix}_newsletter AS t1
              LEFT JOIN {$prefix}_newsletter_sendto AS t2
              ON t1.id = t2.userid
              WHERE t1.status='2'
              GROUP BY t1.id
              ORDER BY t1.email
              LIMIT " . intval($counter) . ", " . intval($nl_config['limit']);
    $result = sql_query($query);

    ob_start();
    echo "<table width=\"90%\" rules=\"all\" class=\"list\"><tr>\n";
    echo _NL_SUBTABLEHEAD;
    echo "</tr>";
    while (list($umail, $ustatus, $userid, $utype, $regdate, $regip, $userid, $anzahl) = sql_fetch_row($result)) {
        echo "<tr>";
        echo "<td>" . $umail . "</td>";
        if ($utype == '1') {
            echo "<td>" . _NL_TYPEHTML . "</td>";
        } else {
            echo "<td>" . _NL_TYPETEXT . "</td>";
        }
        echo "<td>\n";
        echo '<a href="' . adminUrl(PMX_MODULE, 'sendedlist', 'userid=' . $userid) . '">' . $anzahl . '</a>';
        echo "</td>\n";
        echo "<td>" . date("d.m.Y, H:i", $regdate) . "</td>";
        echo "<td>" . $regip . "</td>";
        echo "</tr>\n";
    }
    echo "</table>\n";

    echo "<div align=\"center\">\n";
    _letter_prevnext(adminUrl(PMX_MODULE, 'list_subscribers'), $counter, $count_rows);
    echo "</div>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

/**
 * Show the subject of the send newsletter of the given $userid
 */
function letter_sendedlist()
{
    global $prefix, $nl_config;

    $userid = (empty($_GET['userid'])) ? 0 : intval($_GET['userid']);
    $counter = (empty($_GET['counter'])) ? 0 : intval($_GET['counter']);

    $query = "SELECT t2.id
              FROM {$prefix}_newsletter_sendto AS t2
              INNER JOIN {$prefix}_newsletter_send AS t1
              ON t1.id = t2.newsletterid
              WHERE t2.userid =" . intval($userid);
    $result = sql_query($query);
    $count_rows = sql_num_rows($result);

    $query = "SELECT t1.subject, t2.date, t1.id, t2.id, t2.userid, t2.newsletterid
              FROM {$prefix}_newsletter_send AS t1, {$prefix}_newsletter_sendto AS t2
              WHERE (t1.id = t2.newsletterid) and (t2.userid ='$userid')
              LIMIT " . intval($counter) . "," . intval($nl_config['limit']) . "";
    $result = sql_query($query);

    ob_start();
    echo "<h3>" . _NL_SENDLETTERS . "</h3>";
    echo "<table rules=\"all\" class=\"list\"><tr>\n";
    echo _NL_SENDLETTERSHEAD;
    while (list($subject, $date, $id) = sql_fetch_row($result)) {
        echo "<tr>\n";
        echo "<td>\n";
        echo '<a href="' . adminUrl(PMX_MODULE, 'show', 'id=' . $id) . '">' . mxPrepareToDisplay($subject) . '</a>';
        echo "</td>\n";
        echo "<td>" . $date . "</td>";
        echo "</tr>";
    }
    echo "</table>";

    echo "<div align=\"center\">\n";
    _letter_prevnext(adminUrl(PMX_MODULE, 'sendedlist', "userid=" . $userid), $counter, $count_rows);
    echo "</div>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}
/**
 * Prints a survey of all send letters by now
 */

function letter_list_letters()
{
    global $prefix, $nl_config;

    $counter = (empty($_GET['counter'])) ? 0 : intval($_GET['counter']);

    $query = "SELECT COUNT(id) FROM {$prefix}_newsletter_send";
    $result = sql_query($query);
    list($count_rows) = sql_fetch_row($result);

    $query = "SELECT subject, send, id
              FROM {$prefix}_newsletter_send
              LIMIT " . intval($counter) . ", " . intval($nl_config['limit']);
    $result = sql_query($query);

    ob_start();
    echo "<h3>" . _NL_VIEWLETTER . "</h3>";
    echo "<table rules=\"all\" class=\"list\"><tr>\n";
    echo _NL_SENDLETTERSHEAD;
    while (list($subject, $date, $id) = sql_fetch_row($result)) {
        echo "<tr>\n";
        echo "<td>\n";
        echo '<a href="' . adminUrl(PMX_MODULE, 'show', 'id=' . $id) . '">' . mxPrepareToDisplay($subject) . '</a>';
        echo "</td>\n";
        echo "<td>" . $date . "</td>\n";
        echo "</tr>\n";
    }
    echo "</table>\n";

    echo "<div align=\"center\">\n";
    _letter_prevnext(adminUrl(PMX_MODULE, 'list_letters'), $counter, $count_rows);
    echo "</div>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

function letter_doi($message = '')
{
    global $prefix;
    ob_start();

    if ($message) {
        echo '<div class="warning error">' . $message . '</div><br /><br />';
    }

    echo "<b>" . _NL_DOI . "</b>\n";
    echo "<br /><br />";
    echo _NL_DOIINTRO;
    echo "<br /><br /><br />";
    echo _NL_DOISENDIT;
    echo "<br /><br />";
    echo "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE, 'doi') . "\">\n";
    echo "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/doi_send\" />";
    echo "<input type=\"hidden\" name=\"check\" value=\"0\" />";
    echo "<input type=\"checkbox\" name=\"check\" value=\"1\" />&nbsp;&nbsp;" . _NL_DOISENDITCHECK . "\n";
    echo "<br /><br />";
    echo "<input type=\"submit\" value=\"" . _NL_SENDIT . "\" />&nbsp;&nbsp;\n";
    echo "<input type=\"button\" onclick=\"history.go(-1)\" value=\"" . _NL_DOICANCEL . "\" /></form>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

function letter_doi_send()
{
    global $prefix, $module_name, $sitename, $slogan;

    if (empty($_POST['check'])) {
        return letter_doi(_NL_DOIERROR);
    }

    $nlquery = sql_query("SELECT id, email FROM {$prefix}_newsletter WHERE status='2'");
    @ini_set("max_execution_time", "300");
    mxBulkMail(true);
    $cnt = 0;
    $checkkey = time();
    while (list($id, $email) = sql_fetch_row($nlquery)) {
        $buildlink = PMX_HOME_URL . '/modules.php?name=' . $module_name . '&confirm=' . $id . '.' . _letter_get_crc($email) . '.' . $checkkey;

        $message = _NL_DOIMAIL1 . "\n\n\t" . PMX_HOME_URL . "\n\t" . $sitename . "\n\t" . $slogan . "\n\n" . _NL_DOIMAIL2 . "\n" . $buildlink . "\n\n\n" . _NL_DOIMAIL3 . "\n\n" . $sitename . " (" . PMX_HOME_URL . ")\n";
        if (mxMail($email, _NL_DOIMAILSUB . $sitename, $message)) {
            sql_query("UPDATE " . $prefix . "_newsletter
                        SET status=3, checkkey=" . $checkkey . "
                        WHERE id='" . intval($id) . "'");
            $cnt++;
        }
    }
    mxBulkMail(false);
    @ini_restore("max_execution_time");

    ob_start();

    echo "<div align=\"center\">\n";
    echo "<div class=\"important\"><b>" . $cnt . "</b> " . _NL_OK . "</div>";
    echo "<br /><br /><br />";
    echo "</div>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

function letter_doi_list()
{
    global $prefix;
    ob_start();

    echo "<b>" . _NL_DOILIST . "</b>\n";
    echo "<br /><br />";
    echo _NL_DOILISTTEXT;
    echo "<br /><br />";
    echo "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE, 'doi_list') . "\">\n";
    echo "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/doi_listsend\" />\n";
    echo "<input type=\"submit\" value=\"" . _NL_SENDIT . "\" />&nbsp;&nbsp;\n";
    echo "<input type=\"button\" onclick=\"history.go(-1)\" value=\"" . _NL_DOICANCEL . "\" /></form>\n";

    $content = ob_get_clean();
    return letter_adminpage($content);
}

function letter_doi_listsend()
{
    global $prefix, $adminmail, $sitename, $slogan;
    $result = sql_query("SELECT id FROM " . $prefix . "_newsletter WHERE status='2'");
    $count = sql_num_rows($result);
    $doilist = "-----------------------------------------------------------------\n"
     . "List of active newsletter subscribers from the virtual host:\n\n"
     . "Server-Name:\t" . $_SERVER['SERVER_NAME'] . "\n"
     . "Server-Admin:\t" . $_SERVER['SERVER_ADMIN'] . "\n"
     . "Server-IP:\t" . $_SERVER['SERVER_ADDR'] . "\n\n"
     . "running pragmaMx Content-Management-System:\n\n"
     . "Site-Name:\t" . $sitename . "\n"
     . "Site-Admin:\t" . $adminmail . "\n"
     . "Site-URL:\t" . PMX_HOME_URL . "\n"
     . "Site-Slogan:\t" . $slogan . "\n\n"
     . "Number of active newsletter subscribers: " . $count . "\n\n"
     . "Subscribing to this newsletter is done in a double-opt-in\n"
     . "process. All informations transmited by each user during the\n"
     . "registration process over the activation-link are listed below.\n"
     . "-----------------------------------------------------------------\n";
    $buildquery = sql_query("SELECT id, email, regdate, regip, reghost FROM " . $prefix . "_newsletter WHERE status='2' ORDER BY email");
    while (list($id, $email, $regdate, $regip, $reghost) = sql_fetch_row($buildquery)) {
        $doilist .= "\n" . $email . "\n\tEntry-ID: " . $id . "\n\tReg-Date (GMT): " . gmdate("d.m.Y, H:m:s", $regdate) . "\n\tReg-IP: " . $regip . "\n\tReg-Host: " . $reghost . "\n";
    }

    if (mxMail($adminmail, "Double-Opt-In List for: " . $sitename, $doilist)) {
        return mxRedirect(adminUrl(PMX_MODULE), _NL_DOILISTSENDOK);
    } else {
        return mxRedirect(adminUrl(PMX_MODULE), _NL_ERR_NOTSEND, 5);
    }
}

function _letter_doi_clean()
{
    global $prefix;
    // Double-Opt-In Check
    // TODO: mit Cookie einschränken!!
    $olderthan = MX_TIME - 604800;
    $doicheck = sql_query("SELECT id FROM " . $prefix . "_newsletter WHERE status='3' AND checkkey < $olderthan");
    while (list($doideath) = sql_fetch_row($doicheck)) {
        sql_query("DELETE FROM " . $prefix . "_newsletter WHERE id = $doideath");
        sql_query("DELETE FROM " . $prefix . "_newsletter_sendto WHERE userid = $doideath");
    }
}
/**
 * Creates navigation-links previos/next page descending to the given parameter
 * -------------------------------------------------------------------------------
 * Erstellt Navigationsleiste vorige/naechste Seite abhaengig von den uebergebenen Parametern
 */
function _letter_prevnext($paramto, $counter, $count_rows)
{
    global $nl_config;

    $count_rows = intval($count_rows);
    $limit = intval($nl_config['limit']);

    $nextlink = $paramto . "&amp;counter=" . ($counter + $limit);
    $prevlink = $paramto . "&amp;counter=" . ($counter - $limit);

    switch (true) {
        case ($counter == 0) && ($count_rows > ($counter + $limit)):
            $prevlink = "";
            break;
        case ($counter >= $limit) && ($count_rows > ($counter + $limit)):
            break;
        case ($counter >= $limit) && ($count_rows <= ($counter + $limit)):
            $nextlink = "";
            break;
        default:
            $prevlink = "";
            $nextlink = "";
    }

    ?>
<div align="center">
  <a href="<?php echo $prevlink ?>">&#60;&#60;&#60;&nbsp;<?php echo _NL_PREVENTRY ?></a>
  &nbsp;&nbsp;&nbsp;
  <a href="<?php echo $nextlink ?>"><?php echo _NL_NEXTENTRY ?>&nbsp;&#62;&#62;&#62;</a>
</div>
<br /><br />
<?php
}

/**
 * Calls the different functions of the Addon
 * -------------------------------------------------------------------------------
 * Ruft die einzelnen Funktionen fuer das Addon auf
 */

switch ($op) {
    case PMX_MODULE . '/send':
        letter_send();
        break;

    case PMX_MODULE . '/list_subscribers' :
        letter_list_subscribers();
        break;

    case PMX_MODULE . '/sendedlist':
        letter_sendedlist();
        break;

    case PMX_MODULE . '/show':
        letter_show_letter();
        break;

    case PMX_MODULE . '/list_letters':
        letter_list_letters();
        break;

    case PMX_MODULE . '/doi' :
        letter_doi();
        break;

    case PMX_MODULE . '/doi_send':
        letter_doi_send();
        break;

    case PMX_MODULE . '/doi_list':
        letter_doi_list();
        break;

    case PMX_MODULE . '/doi_listsend':
        letter_doi_listsend();
        break;

    default:
        letter_admin();
        break;
}

?>