<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

$changeuserdata = false;

unset($sqlqry);

if (isset($tables["{$prefix}_newsletter"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_newsletter");
    if (!isset($tf['regdate'])) $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter` ADD `regdate` int(10) NOT NULL default '0';";

    switch (true) {
        case !isset($tf['reghost']):
            $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter` ADD `reghost` varchar(100) NOT NULL default '';";
            break;
        case $tf['reghost']['Default'] === null:
        case $tf['reghost']['Type'] != 'varchar(100)':
            $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter`
                CHANGE `reghost` `reghost` VARCHAR( 100 ) NOT NULL default ''";
    }

    switch (true) {
        case !isset($tf['regip']):
            $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter` ADD `regip` varchar(40) NOT NULL default '';";
            break;
        case $tf['regip']['Type'] != 'varchar(40)':
            $sqlqry[] = "ALTER TABLE `${prefix}_newsletter`
              CHANGE `regip` `regip` varchar(40) NOT NULL DEFAULT ''
              ";
    }

    if (!isset($tf['uid'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter` ADD `uid` INT( 11 ) NULL AFTER `id`, ADD INDEX ( `uid` ) ;";
        $changeuserdata = true;
    }
} else {
    if (!setupTableExist("{$prefix}_newsletter", true)) {
        $sqlqry[] = "
CREATE TABLE `{$prefix}_newsletter` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) DEFAULT NULL,
  `email` varchar(100) NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '0',
  `html` int(11) NOT NULL DEFAULT '0',
  `checkkey` int(11) NOT NULL DEFAULT '0',
  `regdate` int(10) NOT NULL DEFAULT '0',
  `regip` varchar(40) NOT NULL DEFAULT '',
  `reghost` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
    }
}

if (!isset($tables["{$prefix}_newsletter_send"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_newsletter_send` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subject` varchar(255) DEFAULT NULL,
  `text` text,
  `html` text,
  `more` text,
  `send` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    $tf = setupGetTableFields("{$prefix}_newsletter_send");

    switch (true) {
        case $tf['send']['Type'] != 'timestamp':
        case $tf['send']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_newsletter_send` SET `send` = NOW( ) WHERE `send` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `${prefix}_newsletter_send`
                CHANGE `send` `send` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
    if (!isset($tf['more'])) $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter_send` ADD `more` TEXT NULL DEFAULT NULL AFTER `html`;";

    $indexes = setupGetTableIndexes("{$prefix}_newsletter_send");
    if (isset($indexes['id'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter` DROP PRIMARY KEY , ADD PRIMARY KEY ( `id` );";
        $sqlqry[] = "ALTER TABLE `{$prefix}_newsletter_send` DROP INDEX `id`;";
    }
}

if (!isset($tables["{$prefix}_newsletter_sendto"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_newsletter_sendto` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `newsletterid` int(11) NOT NULL default '0',
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    $tf = setupGetTableFields("${prefix}_newsletter_sendto");
    switch (true) {
        case $tf['date']['Type'] != 'timestamp':
        case $tf['date']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_newsletter_sendto` SET `date` = NOW( ) WHERE `date` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `${prefix}_newsletter_sendto`
                CHANGE `date` `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

/* User-ID in Newsletter-Tabelle eintragen */
if ($changeuserdata) {
    $result = sql_query("SELECT n.id, u.uid, n.uid
            FROM `{$prefix}_newsletter` AS n
            INNER JOIN `${user_prefix}_users` AS u
              ON n.email = u.email
            WHERE ISNULL(n.uid)
            ORDER BY u.uid DESC");
    if ($result) {
        while (list($id, $uid) = sql_fetch_row($result)) {
            if ($id && $uid) {
                $sqlqry[$id] = "UPDATE `{$prefix}_newsletter` SET uid=" . intval($uid) . " WHERE id=" . intval($id) . "";
            }
        }
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>