<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(__DIR__));

unset($sqlqry);

if (!isset($tables["${prefix}_seccont"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_seccont` (
  `artid` int(11) NOT NULL AUTO_INCREMENT,
  `secid` int(11) NOT NULL DEFAULT '0',
  `title` text COLLATE utf8_unicode_ci,
  `content` longtext COLLATE utf8_unicode_ci,
  `counter` int(11) NOT NULL DEFAULT '0',
  `slanguage` varchar(30) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `stime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`artid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    $tf = setupGetTableFields("${prefix}_seccont");

    if (!isset($tf['stime'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_seccont` ADD `stime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";
    }

    switch (true) {
      case $tf['title']['Default'] !== null:
      case $tf['content']['Default'] !== null:
      case $tf['content']['Type'] != 'longtext':
        $sqlqry[] = "ALTER TABLE `${prefix}_seccont`
                CHANGE `title` `title` text NULL,
                CHANGE `content` `content` longtext NULL";
    }
}

if (!isset($tables["${prefix}_sections"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_sections` (
  `secid` int(11) NOT NULL AUTO_INCREMENT,
  `secname` varchar(40) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `image` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`secid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_sections");
    if ($tf['image']['Type'] != 'varchar(100)') {
        $sqlqry[] = "ALTER TABLE `${prefix}_sections` CHANGE `image` `image` varchar(100) NOT NULL default ''";
    }
    // cportal
    if (isset($tf['custom_d'])) $sqlqry[] = "ALTER TABLE `${prefix}_sections` DROP custom_d;";
    if (isset($tf['custom_e'])) $sqlqry[] = "ALTER TABLE `${prefix}_sections` DROP custom_e;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_seccont"])) {
    // Pagebreaks konvertieren
    $sqlqry = setup_convert_pagebreak("${prefix}_seccont", 'content', 'artid');
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>