<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(__DIR__);
mxGetLangfile($module_name);
pmxBase::set("plugins",1);
$sectionsimagepath = PMX_IMAGE_PATH . 'sections/';

function listsections()
{
    global $sitename, $prefix, $pagetitle, $module_name, $sectionsimagepath;
    $pagetitle = _SECINDEX;

    $result = sql_query("SELECT DISTINCT s.secid, s.secname, s.image
              FROM " . $prefix . "_sections AS s
              INNER JOIN " . $prefix . "_seccont AS a
                ON s.secid = a.secid
              ORDER BY s.secname");

    include('header.php');
    OpenTable();
    echo "
  	<h2>" . _SECWELCOME . " $sitename.</h2>
  	<p>" . _YOUCANFIND . '</p><br />
  	<table width="100%" border="0" cellspacing="0" cellpadding="5" align="center">';
    $count = 0;
    while (list($secid, $secname, $image) = sql_fetch_row($result)) {
        $secname = (trim($secname)) ? $secname : _NOTITLE;

        if (is_file($sectionsimagepath . $image)) {
            $image = $sectionsimagepath . $image;
        } else {
            $image = PMX_IMAGE_PATH . 'noimg.png';
        }
        $image = mxCreateImage($image, $secname, array('title' => $secname, 'style' => 'max-height:100px;max-width:100px;'));

        if ($count == 4 || $count == 0) {
            echo '<tr valign="bottom">';
            $count = 0;
        }

        $count++;
        echo '<td width="25%" align="center"><a href="modules.php?name=' . $module_name . '&amp;secid=' . $secid . '">' . $image . '<br />' . $secname . '</a></td>';
        if ($count == 4) {
            echo "</tr>";
        }
    }
    if ($count > 1 && $count < 4) {
        echo '</tr>';
    }
    echo "</table>";
    CloseTable();
    include('footer.php');
}

function listarticles()
{
    global $prefix, $pagetitle, $module_name, $sectionsimagepath;
    $secid = (empty($_REQUEST['secid'])) ? 1 : intval($_REQUEST['secid']);

    $querylang = "";
    if ($GLOBALS["multilingual"] == 1) {
        if (strpos($GLOBALS['currentlang'], 'german') === 0) $thislang = "german";
        else $thislang = $GLOBALS["currentlang"];
        $querylang = "AND (slanguage LIKE '$thislang%' OR slanguage = '')";
    }

    $result = sql_query("select secname, image from " . $prefix . "_sections where secid=" . intval($secid));
    list($secname, $image) = sql_fetch_row($result);
    $secname = (trim($secname)) ? $secname : _NOTITLE;

    if (is_file($sectionsimagepath . $image)) {
        $image = $sectionsimagepath . $image;
    } else {
        $image = PMX_IMAGE_PATH . 'noimg.png';
    }
    $image = mxCreateImage($image, $secname, array('title' => $secname, 'class' => 'float-right', 'style' => 'max-height:100px;max-width:100px;'));

    $printimg = mxCreateImage('images/print.gif', _PRINTER);

    $pagetitle = $secname;
    include('header.php');
    OpenTable();
    echo "" . $image . "
  	<h2 class=\"title\">" . _THISISSEC . " &lsquo;" . $secname . "&rsquo;.</h2>
  	<p>" . _FOLLOWINGART . "</p><br />
  	<table align=\"center\" class=\"form align-center\">";
    $result = sql_query("select artid, secid, title, content, counter from " . $prefix . "_seccont where secid=" . intval($secid) . " $querylang order by title");
    while (list($artid, $secid, $title, $content, $counter) = sql_fetch_row($result)) {
        $title = (trim($title)) ? $title : _NOTITLE;
        echo '<tr valign="top">
  		<td><strong><big>&middot;</big></strong></td>
  		<td><a href="modules.php?name=' . $module_name . '&amp;artid=' . $artid . '">' . $title . '</a></td>
  		<td nowrap="nowrap" class="tiny">(' . $counter . ' ' . _READS . ')</td>
  		<td><a href="modules.php?name=' . $module_name . '&amp;op=printpage&amp;artid=' . $artid . '" rel="nofollow">' . $printimg . '</a></td>
  		</tr>
  		';
    }
    echo "</table>
  	<br /><br /><br />
  	<center>[&nbsp;<a href=\"modules.php?name=" . $module_name . "\">" . _SECRETURN . "</a>&nbsp;]</center>";
    CloseTable();
    include('footer.php');
}

function viewarticle()
{
    global $prefix, $pagetitle, $module_name;
    $artid = (empty($_REQUEST['artid'])) ? 0 : intval($_REQUEST['artid']);
    $page = (empty($_REQUEST['page'])) ? 1 : intval($_REQUEST['page']);
    $result = sql_query("select artid, secid, title, content, counter from " . $prefix . "_seccont where artid=" . intval($artid));
    list($artid, $secid, $title, $content, $view_counter) = sql_fetch_row($result);
    $result = sql_query("select secid, secname from " . $prefix . "_sections where secid=" . intval($secid));
    list($secid, $secname) = sql_fetch_row($result);
    $secname = (trim($secname)) ? $secname : _NOTITLE;
    $words = sizeof(preg_split('#\s+#', strip_tags($content)));
    $contentpages = pmx_split_pages($content);
    $content_toview = '';
    $pageno = 0;
    foreach($contentpages as $i => $content) {
        $content = trim($content);
        if (empty($content)) {
            continue;
        }
        $pageno++;
        if ($page >= $pageno) {
            $content_toview = $content;
        }
    }
    if ($page > $pageno) {
        $page = $pageno;
    }
    if ($page == 1) {
        sql_query("update " . $prefix . "_seccont set counter=counter+1 where artid='" . intval($artid) . "'");
    }

    $pager = '';
    $start = '';
    $ende = '';
    $counter = 1;
    $link = 'modules.php?name=' . $module_name . '&amp;artid=' . $artid . '&amp;page=%d';
    if ($page > 3 && $pageno > 6) {
        $start = '<a href="' . sprintf($link, 1) . '" title="' . _GOTOPAGEFIRST . '">1&nbsp;<span class="arrows">&laquo;</span></a><span class="points">..</span>';
        if ($page >= $pageno - 3) {
            $counter = $page - ($page - $pageno + 4);
        } else {
            $counter = $page - 1;
        }
    }
    // Schleife durch Seitenzahlen
    while ($counter <= $pageno) {
        if (($counter > 5) && ($counter > $page + 2) && ($counter < $pageno) && $pageno > 6) {
            $ende = '<span class="points">..</span><a href="' . sprintf($link, $pageno) . '" title="' . _GOTOPAGELAST . '"><span class="arrows">&raquo;</span>&nbsp;' . $pageno . ' </a>';
            break;
        } else if ($counter == $page) {
            $part[] = '<span class="current" title="' . _PAGE . '&nbsp;' . $page . ' ' . _OF . ' ' . $pageno . '">' . $counter . '</span>';
        } else {
            $part[] = '<a href="' . sprintf($link, $counter) . '" title="' . _GOTOPAGE . ' ' . $counter . '">' . $counter . '</a>';
        }
        $counter++;
    }
    if (isset($part)) {
        $pager = '
        <span class="counter">' . _PAGE . '&nbsp;' . $page . '&nbsp;' . _OF . '&nbsp;' . $pageno . '
        </span>' . $start . implode($part) . $ende . '
        ';
    }

    $adminlink = (MX_IS_ADMIN) ? "<p>[&nbsp;<a href=\"" . adminUrl($module_name, 'artedit', "artid=" . $artid) . "\">" . _EDIT . "</a> | <a href=\"" . adminUrl($module_name, "artdelete", "artid=" . $artid . "&amp;ok=0") . "\">" . _DELETE . "</a>&nbsp;]</p>" : "";
    $pagetitle = $title . (($page < 2) ? '' : ', ' . _PAGE . ' ' . $page);
    include("header.php");
    OpenTable();
    echo '<h2 class="title">' . $title . '</h2>';
    if ($pageno > 1) {
        echo '<div class="pagination align-right">' . $pager . "</div>";
    }
    echo '<div class="content">' . $content_toview . '</div>';
    if ($pageno > 1) {
        echo '<br /><br /><div class="pagination align-right">' . $pager . '</div>';
    }
    if ($page == 1 || $page == $pageno) {
        echo '
        <div class="content">(' . $words . ' ' . _TOTALWORDS . ')<br />
        (' . $view_counter . ' ' . _READS . ') &nbsp;&nbsp;
        <a href="modules.php?name=' . $module_name . '&amp;op=printpage&amp;artid=' . $artid . '" rel="nofollow">' . mxCreateImage('images/print.gif', _PRINTER) . '</a>
        </div>
        <br /><br />
        <div align="center">
        [&nbsp;<a href="modules.php?name=' . $module_name . '&amp;secid=' . $secid . '">' . _BACKTO . ' ' . $secname . '</a>
         |
        <a href="modules.php?name=' . $module_name . '">' . _SECINDEX . '</a>&nbsp;]
        </div>
        ';
    }
    echo $adminlink;
    CloseTable();
    include('footer.php');
}

function PrintSecPage()
{
    global $site_logo, $sitename, $prefix, $module_name;

    $artid = (empty($_REQUEST['artid'])) ? 1 : intval($_REQUEST['artid']);
    $result = sql_query("SELECT title, content FROM " . $prefix . "_seccont WHERE artid=" . intval($artid));
    list($title, $content) = sql_fetch_row($result);

    $target = 'modules.php?name=' . $module_name . '&artid=' . $artid;

    if (!MX_IS_ADMIN && (empty($_SERVER['HTTP_REFERER']) || strpos($_SERVER['HTTP_REFERER'], PMX_HOME_URL) === false)) {
        header('HTTP/1.1 301 Moved Permanently');
        header('Status: 301 Moved Permanently');
        return mxRedirect($target);
    }

    /* versch. HTTP Header senden */
    if (!headers_sent()) {
        header('Content-type: text/html; charset=utf-8');
        header('Content-Language: ' . _DOC_LANGUAGE);
        header('X-Powered-By: pragmaMx ' . PMX_VERSION);
    }

    $title = strip_tags(str_replace('&nbsp;', ' ', $title));
    $logo = (file_exists($site_logo)) ? '<p>' . mxCreateImage($site_logo, $sitename) . '</p>' : '';

    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
  <meta http-equiv="content-language" content="<?php echo _DOC_LANGUAGE ?>" />
  <meta name="robots" content="NOINDEX, NOFOLLOW" />
  <link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=<?php echo MX_THEME ?>" />
  <link rel="stylesheet" type="text/css" href="themes/<?php echo MX_THEME ?>/style/style.css" />
  <link rel="stylesheet" type="text/css" href="layout/style/printpage.css" />
  <title><?php echo $title ?></title>
</head>

<body class="printpage">
  <div id="p-page">
    <div id="p-head">
      <?php echo $logo ?>
      <h2><?php echo $title ?></h2>
    </div>

    <div id="p-main" class="content">
      <?php echo $content ?>
    </div>

    <div id="p-foot">
      <p><?php echo _COMESFROM ?> <?php echo $sitename ?><br />
      <?php echo PMX_HOME_URL ?></p>

      <p><?php echo _THEURL ?><br />
      <?php echo htmlspecialchars($target) ?></p>
    </div>
  </div>
</body>
</html>
<?php
}

if (isset($_REQUEST['sop']) && !isset($_REQUEST['op'])) {
    $_REQUEST['op'] = $_REQUEST['sop'];
}
if (empty($_REQUEST['op'])) {
    if (!empty($_REQUEST['artid'])) {
        $op = 'viewarticle';
    } else if (!empty($_REQUEST['secid'])) {
        $op = 'listarticles';
    } else {
        $op = '';
    }
} else {
    $op = $_REQUEST['op'];
}

switch ($op) {
    case 'viewarticle':
        viewarticle();
        break;

    case 'listarticles':
        listarticles();
        break;

    case 'printpage':
        PrintSecPage();
        break;

    default:
        listsections();
        break;
}

?>