<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

$convertentries = false;

unset($sqlqry);

if (!isset($tables["${prefix}_siteupdate"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_siteupdate` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(25) NOT NULL default '',
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `files` varchar(100) NOT NULL default '',
  `updates` text,
  `bugs` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_siteupdate");
    // falls anderes siteupdate Modul installiert ist (cp)
    if (isset($tf['updates_E'])) $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate` DROP `updates_E` ";
    // ab pragmaMx 1.12 keine mailadresse mehr...
    if (isset($tf['email'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate` DROP `email` ";
        $convertentries = true; // und Daten konvertieren...
    }

    switch (true) {
        case $tf['id']['Type'] != 'int(11) unsigned':
        case $tf['name']['Type'] != 'varchar(25)':
        case $tf['name']['Default'] === null:
        case $tf['files']['Type'] != 'varchar(100)':
        case $tf['files']['Default'] === null:
        case $tf['date']['Type'] != 'timestamp':
        case $tf['date']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
             * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_siteupdate` SET `date` = NOW( ) WHERE `date` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate`
                CHANGE `id` `id` INT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT,
                CHANGE `name` `name` VARCHAR( 25 ) NOT NULL default '',
                CHANGE `files` `files` VARCHAR( 100 ) NOT NULL default '',
                CHANGE `date` `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }

    $indexes = setupGetTableIndexes("${prefix}_siteupdate");
    if (isset($indexes['id'])) $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate` DROP INDEX `id` ";
    if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'id') {
        $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate` DROP PRIMARY KEY , ADD PRIMARY KEY ( `id` ) ";
    } else if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_siteupdate` ADD PRIMARY KEY ( `id` ) ";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

/* für pragmaMx 1.12, Zeilenumbrüche und HTML-Tags in Texten konvertieren */
if ($convertentries) {
    $result = sql_query("SELECT * FROM `${prefix}_siteupdate`;");
    if ($result) {
        while ($row = sql_fetch_assoc($result)) {
            $sqlqry[] = "UPDATE `${prefix}_siteupdate` SET
                files='" . sql_real_escape_string(strip_tags($row['files'])) . "',
                updates='" . sql_real_escape_string(nl2br($row['updates'])) . "',
                bugs='" . sql_real_escape_string(nl2br($row['bugs'])) . "'
                WHERE id=" . intval($row['id']) . "";
        }

        if (isset($sqlqry)) {
            setupDoAllQueries($sqlqry);
            unset($sqlqry);
        }
    }
}

?>