<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

global $prefix;

/* Block kann gecached werden? */
$mxblockcache = true;

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

include_once(PMX_MODULES_PATH.$module_name. DS. "includes" . DS ."functions.php");

$startdate = pmx_get_startdate();
$total = pmx_get_totalhits();

$result = sql_query("SELECT SUM(hits), COUNT(lid) from " . $prefix . "_links_links WHERE cid > 0");
list($linkhits, $linkrows) = sql_fetch_row($result);

$result = sql_query("SELECT SUM(hits), COUNT(lid), SUM(filesize * hits) from " . $prefix . "_downloads_downloads WHERE cid > 0");
list($downhits, $downrows, $downsize) = sql_fetch_row($result);

$content = '
<div class="align-center">
<small>' . _WERECEIVED . '</small><br />
<a href="modules.php?name=' . $module_name . '&amp;op=periods"><b>' . pmx_number_format($total) . '</b></a><br />
<small>' . _PAGESVIEWS . ' ' . mx_strftime(_SHORTDATESTRING, $startdate) . '</small><br /><br />
<b>' . pmx_number_format($linkrows) . '</b> ' . _STAT_WEBLINKS . '<br />
<b>' . pmx_number_format($linkhits) . '</b> ' . _TIMESL . ' <br /><br />
<b>' . pmx_number_format($downrows) . '</b> ' . _DOWNS . '<br />
<b>' . pmx_number_format($downhits) . '</b> ' . _TIMES . ' <br />
= <b>' . pmx_number_format(round($downsize / 1024 / 1024)) . '&nbsp;MB</b>
</div>
';

?>