<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

global $prefix;


/**
 * mxCounter()
 *
 * @return
 */
function mxCounter()
{
    global $prefix;

    if (MX_MODULE == 'admin' || MX_IS_ADMIN) {
       return true;
    }

    /* Get the Browser data */
    $browser = load_class('Browser');
    //mxDebugFuncVars($browser);
    $where[] = "(`type`='total' AND `var`='hits')";
    switch (true) {
        case $browser->browser:
            /* ein Browser */
            $where[] = "(`var`='$browser->browser' AND `type`='browser')";
            $isbot = false;
            break;
        case $browser->robot:
            /* ein Bot */
            $where[] = "(`var`='$browser->robot' AND `type`='robot')";
            $isbot = true;
            break;
        default:
            $isbot = false;
    }
    /* das Betriebssystem */
    $where[] = "(`var`='$browser->os' AND `type`='os')";
    $where = implode(" OR ", $where);

    $qry = "UPDATE `${prefix}_counter` SET `count`=count+1 WHERE " . $where;
    $result = sql_system_query($qry);

    /* es müssen genau 3 Datensätze geändert werden !! */
    $affected = sql_affected_rows();
    if ($affected != 3) {
        $types = array('total' => false, 'browser' => false, 'robot' => false, 'os' => false);
        $qry = "SELECT `type` FROM `${prefix}_counter` WHERE " . $where . "";
        $result = sql_system_query($qry);
        while (list($type) = sql_fetch_row($result)) {
            if (isset($types[$type])) {
                $types[$type] = true;
            }
        }

        $vals = array();
        /* fehlende anfügen */
        if (!$types['total']) {
            $vals[] = "('total', 'hits', NULL, 1)";
        }
        if (!$isbot && !$types['browser']) {
            $vals[] = "('browser', '$browser->browser', '$browser->browser_icon', 1)";
        } else if ($isbot && !$types['robot']) {
            $vals[] = "('robot', '$browser->robot', '$browser->robot_icon', 1)";
        }
        if ($browser->os && !$types['os']) {
            $vals[] = "('os', '$browser->os', '$browser->os_icon', 1)";
        }
        if ($vals) {
            $qry = "REPLACE INTO `${prefix}_counter` (`type`, `var`, `icon`, `count`) VALUES " . implode(',', $vals);
            $result = sql_system_query($qry);
        }
    }

    $now = getdate();
    $stmnt = sql_system_query("UPDATE `${prefix}_stats` SET `hits`=hits+1
              WHERE (`year`='$now[year]')
                AND (`month`='$now[mon]')
                AND (`date`='$now[mday]')
                AND (`hour`='$now[hours]')");

    $affected = sql_affected_rows();
    if ($affected==0) {
        $vals = array();
        for ($i = 0; $i <= 23; $i++) {
            $cnt = intval($i == $now['hours']);
            $vals[$i] = " ($now[year], $now[mon], $now[mday] ,$i, $cnt)";
        }
        $qry = "REPLACE INTO `${prefix}_stats` (`year`, `month`, `date`, `hour`,`hits`) VALUES " . implode(',', $vals);
        $result = sql_system_query($qry);
    }
}


/**
 * pmx_get_startdate()
 *
 * @return
 */
function pmx_get_startdate()
{
    static $startdate = 0;
    if ($startdate) {
        return intval($startdate);
    }
    global $prefix;

    $tmpdate = strtotime($GLOBALS['startdate']);
    if ($tmpdate) {
        /* wenn in config gültiges Datum angegeben, dieses verwenden */
        $startdate = $tmpdate;
        return intval($startdate);
    }

    /* ansonsten den ersten Eintrag der Statistik ermitteln */
    $result = sql_query("SELECT year, month, `date` AS day FROM `{$prefix}_stats` WHERE hits>0 ORDER BY year, month, `date`, hour LIMIT 1");
    list($year, $month, $day) = sql_fetch_row($result);
    $startdate = mktime(0, 0, 0, intval($month), intval($day), intval($year));
    return intval($startdate);
}


/**
 * pmx_get_totalhits()
 *
 * @return
 */
function pmx_get_totalhits()
{
    static $total = 0;
    if ($total) {
        return intval($total);
    }
    global $prefix;

    $start = pmx_get_startdate();
    $start = getdate($start);
    $result = sql_query("SELECT SUM(hits) FROM `{$prefix}_stats`
                WHERE hits > 0
                  AND STR_TO_DATE(CONCAT(year, '-', month, '-', `date`), '%Y-%c-%e') >= '$start[year]-$start[mon]-$start[mday]'");

    list($total) = sql_fetch_row($result);

    return intval($total);
}

?>