<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined( 'mxMainFileLoaded' ) or die( 'access denied' );


extract( $block['settings'], EXTR_OVERWRITE );

$module_name = basename( dirname( __DIR__ ) );
mxGetLangfile( $module_name );


if ( ! mxModuleAllowed( $module_name ) ) {
	return true;
}

global $prefix;


// get last poll
$last = sql_query( "SELECT pollID, pollTitle, description
	FROM {$prefix}_poll_desc
    WHERE `artid` = 0
      AND `pollactive` = 1
      " . pmx_multilang_query( 'planguage', 'AND' ) . "
    ORDER BY `pollID` DESC
    LIMIT 1" );
list( $last_id, $last_pollTitle, $last_description ) = sql_fetch_row( $last );

// show only if exists poll
if ( $last_id > 0 ) {

	$content = '';

	$columns = array();

	// get results
	$result = sql_query( "SELECT optionText, optionCount, barcolor
    FROM {$prefix}_poll_data
    WHERE `pollID` = " . $last_id );

	// add first columns
	$columns[] = array( '', '', array( 'role' => 'style' ) );

	// add all other columns
	while ( list( $optionText, $optionCount, $barcolor ) = sql_fetch_row( $result ) ) {
		$columns[] = array( $optionText, (int) $optionCount, '#' . (string) $barcolor );
	}

	// init Charts
	$charts = load_class( 'Charts' );
	$charts->setChart( 'BarChart' );
	$charts->setAnimation( 1000, 'linear' );
	$charts->setData( $columns );

	$content .= '<h4>' . $last_pollTitle . '</h4>';
	$content .= $charts->getTemplate();
	$content .= '<a href="modules.php?name=' . $module_name . '">' . mxTranslate( '_MOREPOLLS' ) . '</a>';

}

?>
