<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration für den Block ----------------------------------- */

/* eine bestimmte Umfrage anzeigen, ansonsten wird die neueste angezeigt */
$pollID = false;

/* Die Beschreibung der Umfrage anzeigen,
  * - 0 = nein, nicht anzeigen
  * - 1 = ja, vollständig,
  * - ein anderer Integerwert kürzt die Beschreibung auf die entspr. Länge
  * Achtung: als Centerblock wird die Beschreibung nicht gekürzt!!
  */
$showdesc = 100;

/* --------- Ende der Konfiguration ----------------------------------------- */
extract($block['settings'], EXTR_OVERWRITE);

global $prefix;

/* der passende Modulname */
$module_name = basename(dirname(__DIR__));

switch (true) {
    case !mxModuleAllowed($module_name):
    case !($functionfile = realpath(__DIR__ . '/../includes/functions.php')):
    case !include_once($functionfile):
        return true;
}

if (!intval($pollID)) {
    $result = sql_query("SELECT pollID
        FROM `{$prefix}_poll_desc`
        WHERE `artid` = 0
          AND `pollactive` = 2
          " . pmx_multilang_query('planguage', 'AND') . "
        ORDER BY `pollID` DESC
        LIMIT 1");
    list($pollID) = sql_fetch_row($result);
}

$content = poll_block($pollID, $block, $showdesc);

/* Blocktitel aus Sprachdatei auslesen */
// $blockfiletitle = _SURVEY;
?>