<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(__DIR__));

$barcolordefaults = array("336699", "669933", "339966");

unset($sqlqry);
// Umfragen-Tabelle anpassen und Standardwert eintragen
if (!isset($tables["{$prefix}_poll_desc"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_desc` (
  `pollID` int(11) NOT NULL auto_increment,
  `pollTitle` varchar(100) NOT NULL default '',
  `timeStamp` int(11) NOT NULL default '0',
  `voters` mediumint(9) NOT NULL default '0',
  `planguage` varchar(30) NOT NULL default '',
  `artid` int(10) NOT NULL default '0',
  `pollactive` tinyint(1) unsigned NOT NULL default '1',
  `onlyonevote` tinyint(1) unsigned NOT NULL default '1',
  `pollcomments` tinyint(1) unsigned NOT NULL default '0',
  `representative` tinyint(1) unsigned NOT NULL default '1',
  `description` text NULL,
  PRIMARY KEY  (`pollID`),
  KEY `pollactive` (`pollactive`),
  KEY `planguage` (`planguage`),
  KEY `artid` (`artid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_poll_data"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_data` (
  `pollID` int(11) NOT NULL default '0',
  `optionText` varchar(100) NOT NULL default '',
  `optionCount` int(11) NOT NULL default '0',
  `barcolor` varchar(6) NOT NULL default '{$barcolordefaults[0]}',
  `voteID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pollID`,`voteID`),
  KEY `pollID` (`pollID`),
  KEY `voteID` (`voteID`),
  KEY `optionText` (`optionText`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_poll_check"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_check` (
  `ip` varchar(40) NOT NULL default '',
  `uid` int(11) unsigned NOT NULL default '0',
  `time` int(11) unsigned NOT NULL default '0',
  `pollID` int(11) unsigned NOT NULL default '0',
  `voteID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ip`,`uid`,`pollID`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_pollcomments"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_pollcomments` (
  `tid` int(11) NOT NULL auto_increment,
  `pid` int(11) default '0',
  `pollID` int(11) default '0',
  `date` datetime default NULL,
  `name` varchar(60) NOT NULL default '',
  `email` varchar(60) default NULL,
  `url` varchar(60) default NULL,
  `host_name` varchar(60) default NULL,
  `subject` varchar(60) NOT NULL default '',
  `comment` text NULL,
  `score` tinyint(4) NOT NULL default '0',
  `reason` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`tid`),
  KEY `pollID` (`pollID`),
  KEY `date` (`date`),
  KEY `name` (`name`),
  KEY `host_name` (`host_name`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Daten einfuegen
$numrows = sql_num_rows(sql_query("SELECT `pollID` FROM `{$prefix}_poll_data` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'sehr gut', 0, 1);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'gut', 0, 2);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'ganz nett', 0, 3);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'gewöhnungsbedürftig', 0, 4);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'na ja ....', 0, 5);";
}

$numrows = sql_num_rows(sql_query("SELECT `voteID` FROM `{$prefix}_poll_data` WHERE `optionText`='' OR ISNULL(`optionText`) LIMIT 1"));
if ($numrows) {
    $sqlqry[] = "DELETE FROM `{$prefix}_poll_data` WHERE `optionText`='' OR ISNULL(`optionText`);";
}
// Umfragen-Tabelle anpassen und Standardwert eintragen
if (isset($tables["{$prefix}_poll_desc"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_poll_desc");
    if (!isset($tf['pollactive'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD `pollactive` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
    } else if ($tf['pollactive']['Type'] != 'tinyint(1) unsigned') {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` CHANGE `pollactive` `pollactive` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1'";
    }

    switch (true) {
        case !isset($tf['pollcomments']):
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD `pollcomments` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
            break;
        case $tf['pollcomments']['Type'] != 'tinyint(1) unsigned':
        case $tf['pollcomments']['Default'] != 0:
        case $tf['pollcomments']['Default'] == 1:
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` CHANGE `pollcomments` `pollcomments` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0'";
            break;
    }

    if (!isset($tf['onlyonevote'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD `onlyonevote` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
    }
    if (!isset($tf['representative'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD `representative` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
    }
    if (!isset($tf['description'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD `description` TEXT NULL;";
    }

    /* wenn die alte globale Einstellung $pollcomm noch existiert und 0 oder 2 ist, bei allen Umfragen die kommentare abschalten */
    if (isset($tf['pollcomments'], $GLOBALS['pollcomm']) && $GLOBALS['pollcomm'] != 1) {
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `pollcomments` = " . intval($GLOBALS['pollcomm']) . " WHERE `pollcomments` <> " . intval($GLOBALS['pollcomm']) . "";
    }
}

$numrows = sql_num_rows(sql_query("SELECT `pollID` FROM `{$prefix}_poll_desc` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_desc` (pollID, pollTitle, timeStamp, voters, planguage, artid, pollactive) VALUES (1, 'Wie gefällt Ihnen diese Seite', " . intval(time()) . ", 0, 'german', 0, 1);";
} else {
    if (!isset($tf['pollactive'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `pollactive` = 1;";
    }
    if (!isset($tf['pollcomments'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `pollcomments` = 1;";
    }
    if (!isset($tf['onlyonevote']) || !isset($tf['representative'])) {
        // wenn die Felder onlyonevote oder representative noch nicht vorhanden war
        // ab pragmaMx 2.0
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `onlyonevote` = 1, `representative` = 1 ;";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["{$prefix}_poll_data"])) {
    // Indexe
    $indexes = setupGetTableIndexes("{$prefix}_poll_data");
    if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` ADD PRIMARY KEY ( `pollID` , `voteID` );";
    } else if (!isset($indexes['PRIMARY']['all_fields']['pollID']) || !isset($indexes['PRIMARY']['all_fields']['voteID'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` DROP PRIMARY KEY , ADD PRIMARY KEY ( `pollID` , `voteID` );";
    }
    if (!isset($indexes['pollID'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` ADD INDEX `pollID` ( `pollID` ) ";
    if (!isset($indexes['voteID'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` ADD INDEX `voteID` ( `voteID` ) ";
    if (!isset($indexes['optionText'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` ADD INDEX `optionText` ( `optionText` ) ";

    $tf = setupGetTableFields("{$prefix}_poll_data");
    if (isset($tf['optionTextE'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` DROP `optionTextE` "; // cp
    if (isset($tf['optionText'])) {
        if ($tf['optionText']['Type'] != 'varchar(100)') $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` CHANGE `optionText` `optionText` VARCHAR( 100 ) NOT NULL DEFAULT '';";
    }

    /* ab pragmaMx 2.0 */
    if (!isset($tf['barcolor'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_data` ADD `barcolor` varchar(6) NOT NULL default '{$barcolordefaults[0]}' AFTER `optionCount`;";
        /* Die Standardfarben eintragen (hier in dieser Datei definiert) */
        $sqlqry[] = "UPDATE `{$prefix}_poll_data` SET `barcolor` = '$barcolordefaults[0]' WHERE `voteID` IN(1,4,7,10,13);";
        $sqlqry[] = "UPDATE `{$prefix}_poll_data` SET `barcolor` = '$barcolordefaults[1]' WHERE `voteID` IN(2,5,8,11,14);";
        $sqlqry[] = "UPDATE `{$prefix}_poll_data` SET `barcolor` = '$barcolordefaults[2]' WHERE `voteID` IN(3,6,9,12,15,0);";
    }
}

if (isset($tables["{$prefix}_poll_check"])) {
    $tf = setupGetTableFields("{$prefix}_poll_check");
    $indexes = setupGetTableIndexes("{$prefix}_poll_check");

    /* ab pragmaMx 2.0 neue Struktur */
    if (!isset($tf['uid']) || !isset($tf['voteID'])) {
        /* check-Tabelle leeren */
        $sqlqry[] = "TRUNCATE `{$prefix}_poll_check`";

        if (!isset($tf['uid'])) {
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` ADD `uid` int(11) unsigned NOT NULL default '0' AFTER `ip`;";
        }
        if (!isset($tf['voteID'])) {
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` ADD `voteID` int(11) unsigned NOT NULL default '0' AFTER `pollID`;";
        }

        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` CHANGE `time` `time`  int(11) unsigned NOT NULL default '0' ";
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` CHANGE `pollID` `pollID`  int(11) unsigned NOT NULL default '0' ";
        $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` CHANGE `ip` `ip` varchar(40) NOT NULL default ''";

        if (isset($indexes['PRIMARY'])) {
            // wenn alter primär index vorhanden, diesen vorher löschen
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` DROP PRIMARY KEY , ADD PRIMARY KEY ( `ip`,`uid`,`pollID` ) ";
        } else {
            $sqlqry[] = "ALTER TABLE `{$prefix}_poll_check` ADD PRIMARY KEY ( `ip`,`uid`,`pollID` ) ";
        }
    }
}

if (isset($tables["{$prefix}_poll_desc"])) {
    $indexes = setupGetTableIndexes("{$prefix}_poll_desc");
    if (!isset($indexes['pollactive'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD INDEX `pollactive` ( `pollactive` ) ";
    if (!isset($indexes['planguage'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD INDEX `planguage` ( `planguage` ) ";
    if (!isset($indexes['artid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` ADD INDEX `artid` ( `artid` ) ";

    $tf = setupGetTableFields("{$prefix}_poll_desc");
    if (isset($tf['comments'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` DROP `comments` "; // ab nuke 7.x
    if (isset($tf['pollTitleE'])) $sqlqry[] = "ALTER TABLE `{$prefix}_poll_desc` DROP `pollTitleE` "; // cp
}

if (isset($tables["{$prefix}_pollcomments"])) {
    $indexes = setupGetTableIndexes("{$prefix}_pollcomments");
    if (!isset($indexes['pollID'])) $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments` ADD INDEX `pollID` ( `pollID` ) ";
    if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments` ADD INDEX `date` ( `date` ) ";
    if (!isset($indexes['name'])) $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments` ADD INDEX `name` ( `name` ) ";
    if (!isset($indexes['host_name'])) $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments` ADD INDEX `host_name` ( `host_name` ) ";
    // nuke 7.9
    $tf = setupGetTableFields("{$prefix}_pollcomments");
    if (isset($tf['last_moderation_ip'])) $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments` DROP `last_moderation_ip` ";
}

if (isset($tables["{$prefix}_pollcomments"])) {
    $tf = setupGetTableFields("{$prefix}_pollcomments");
    if ($tf['comment']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_pollcomments`
                CHANGE `comment` `comment` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// aufraeumen
unset($numrows);

?>