<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*
#Surveys

RewriteRule ^Surveys-results-.*-([0-9]+)(-.*)?\.html$ mod.php?name=Surveys&op=results&pollID=$1&_MORE_=$2 [L]
RewriteRule ^Surveys-title-.*-([0-9]+)(-.*)?\.html$ mod.php?name=Surveys&pollID=$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $poll = array();
    $results = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case ((isset($para['op']) && $para['op'] == 'results') && (isset($para['pollID']) && intval($para['pollID']))):
                $results[0][] = $para['pollID'];
                $results[$key] = $para;
                break;
            case ((!isset($para['op'])) && isset($para['pollID']) && intval($para['pollID'])):
                $poll[0][] = $para['pollID'];
                $poll[$key] = $para;
                break;
            case (isset($para['pid']) && intval($para['pid']) && !(isset($para['pa']))):
                $pid[0][] = $para['pid'];
                $pid[$key] = $para;
                break;
        }
    }

    /**
     * Surveys-KATEGORIENAME-cat63.html
     * RewriteRule ^(Surveys)-.*-cat([0-9]+)(-.*)\.html$ mod.php?$1&________________________cid-$2$3 [L]
     */
    if ($results) {
        $inquery = implode(',', array_unique(array_shift($results)));
        $qry = "SELECT pollID, pollTitle FROM {$prefix}_poll_desc WHERE `pollID` in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($catid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$catid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($results as $key => $link) {
            if (isset($titles[$link['pollID']])) {
                /**
                 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
                 * also getrennt mit den Bindestrichen
                 * Einstellung:
                 * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
                 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
                 * übergeben
                 */
                $new_url = pmxModrewrite::title_parameters($link, 'pollID', 'op');
                /**
                 * den neuen URL zusammensetzen
                 * Einstellung:
                 * nach belieben zusammensetzen und entspr. die .htaccess anpassen
                 */
                // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
                $new_url = $name . '-results-' . $titles[$link['pollID']] . '-' . $link['pollID'] . $new_url;
                /**
                 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
                 * Einstellung: keine, muss exakt so bleiben!
                 */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /**
     */
    if ($poll) {
        $inquery = implode(',', array_unique(array_shift($poll)));
        $qry = "SELECT pollID, pollTitle FROM {$prefix}_poll_desc WHERE `pollID` in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($conid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$conid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($poll as $key => $link) {
            if (isset($titles[$link['pollID']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'pollID');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-title-' . $titles[$link['pollID']] . '-' . $link['pollID'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }
}

?>