<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 587 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 22:28:42 +0200 (Mo, 29. Aug 2022) $
 *
 * this file based on:
 * User Guestbook
 * Copyright (c)  Jens Ferner - http://www.netz-id.de
 * micro - http://guggemahier.de
 * modified by (c) 2005 by jubilee - http://www.marx-city.de
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminuser')) {
    mxErrorScreen('Access Denied');
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);
// mxSessionSetVar('panel', MX_ADMINPANEL_USERS);
function usergbconfigsave()
{
    global $module_name;

    extract($_POST);

    $xumbruch = intval($xumbruch);
    $xmaxentrys = intval($xmaxentrys);
    $xmaxchars = intval($xmaxchars);
    $xanzahl = intval($xanzahl);
    $xindex = ($xindex == 1) ? $xindex : 0;
    $xPMbeiEintrag = ($xPMbeiEintrag == 1) ? $xPMbeiEintrag : 0;
    $xAddSmilies = ($xAddSmilies == 1) ? $xAddSmilies : 0;
    $xallow_backup = ($xallow_backup == 1) ? $xallow_backup : 0;
    $xallow_html = ($xallow_html == 1) ? $xallow_html : 0;
    $xuserdeniedpost = ($xuserdeniedpost == 1) ? $xuserdeniedpost : 0;
    $xuseraddsig = ($xuseraddsig == 1) ? $xuseraddsig : 0;
    $xwysiwyg_userguest = ($xwysiwyg_userguest == 1) ? $xwysiwyg_userguest : 0;
    $xpoints1 = intval($xpoints1);
    $xpoints2 = intval($xpoints2);

    $content = "<?php\n";
    $content .= "/*\n";
    $content .= " pragmaMx - Web Content Management System\n";
    $content .= " Copyright by pragmaMx Developer Team - http://www.pragmamx.org\n";
    $content .= " */\n\n";
    $content .= "defined('mxMainFileLoaded') or die('access denied');\n\n";
    $content .= "\$index = $xindex;\n";
    $content .= "\$umbruch = $xumbruch;\n";
    $content .= "\$maxentrys = $xmaxentrys;\n";
    $content .= "\$maxchars = $xmaxchars;\n";
    $content .= "\$PMbeiEintrag = $xPMbeiEintrag;\n";
    $content .= "\$AddSmilies = $xAddSmilies;\n";
    $content .= "\$anzahl = $xanzahl;\n";
    $content .= "\$allow_backup = $xallow_backup;\n";
    $content .= "\$allow_html = $xallow_html;\n";
    $content .= "\$userdeniedpost = $xuserdeniedpost;\n";
    $content .= "\$useraddsig = $xuseraddsig;\n";
    $content .= "\$wysiwyg_userguest = $xwysiwyg_userguest;\n";
    $content .= "\$points1 = $xpoints1;\n";
    $content .= "\$points2 = $xpoints2;\n";
    $content .= "\n";
    $content .= "?>";

    $ok = mx_write_file('modules/' . $module_name . '/settings.php', $content, true);
    /* error > exit */
    if (!$ok) {
        mxErrorScreen(_ADMIN_SETTINGNOSAVED, '', true);
        return;
    }
    /* alles ok > redirect */
    mxRedirect(adminUrl(PMX_MODULE), _ADMIN_SETTINGSAVED, 1);
}

function usergbsettings()
{
    global $module_name;

    /* Standardwerte */
    $index = 0;
    $umbruch = 60;
    $maxentrys = 0;
    $maxchars = 0;
    $PMbeiEintrag = 0;
    $AddSmilies = 1;
    $anzahl = 5;
    $allow_backup = 1;
    $allow_html = 0;
    $userdeniedpost = 0;
    $useraddsig = 0;
    $wysiwyg_userguest = 0;
    $timeformat = "%d.%m.%Y um %H:%M";
    $points1 = 2;
    $points2 = 1;

    require(PMX_MODULES_DIR . DS . $module_name . DS . "settings.php");

    include('header.php');
    GraphicAdmin();
    title(_USERGBTITLE);
    OpenTable();
    echo '
    <fieldset>
      <legend>' . _USERGBSETTINGS . '</legend>
      <form action="' . adminUrl(PMX_MODULE) . '" method="post">
        <table class="form" style="width:100%;">

          <tr>
            <td width="41%">' . _USERGBDISPLAYRIGHTBLOCKS . '</td>
            <td width="59%">';
    if ($index == 1) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xindex" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xindex" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBPMBEIEINTRAG . '</td>
            <td width="59%">';
    if ($PMbeiEintrag == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xPMbeiEintrag" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xPMbeiEintrag" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBADDSMILIES . '</td>
            <td width="59%">';
    if ($AddSmilies == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xAddSmilies" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xAddSmilies" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBBACKUP . '</td>
            <td width="59%">';
    if ($allow_backup == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xallow_backup" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xallow_backup" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBHTML . '</td>
            <td width="59%">';
    if ($allow_html == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xallow_html" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xallow_html" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBDENIEDSELF . '</td>
            <td width="59%">';
    if ($userdeniedpost == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xuserdeniedpost" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xuserdeniedpost" value="0" ' . $check_no . '/>' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBADDUSERSIG . '</td>
            <td width="59%">';
    if ($useraddsig == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xuseraddsig" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xuseraddsig" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>
          <tr>
            <td width="41%">' . _USERGBUSEWYSIWYG . '</td>
            <td width="59%">';
    if ($wysiwyg_userguest == true) {
        $check_yes = 'checked="checked"';
        $check_no = '';
    } else {
        $check_yes = '';
        $check_no = 'checked="checked"';
    }
    echo '
              <input type="radio" name="xwysiwyg_userguest" value="1" ' . $check_yes . ' />' . _USERGBYES . '
              <input type="radio" name="xwysiwyg_userguest" value="0" ' . $check_no . ' />' . _USERGBNO . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBMAXENTRYS . ':</td>
            <td width="59%">
              <input type="text" name="xmaxentrys" size="12" value="' . $maxentrys . '" />
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBMAXCHARS . ':</td>
            <td width="59%">
              <input type="text" name="xmaxchars" size="12" value="' . $maxchars . '" />
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBUBRUCH . ':</td>
            <td width="59%">
              <input type="text" name="xumbruch" size="12" value="' . $umbruch . '" />&nbsp;' . _USERGBZEICHEN . '
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBANZAHL . ':</td>
            <td width="59%">
              <input type="text" name="xanzahl" size="12" value="' . $anzahl . '" />
            </td>
          </tr>

          <tr>
            <td width="41%">' . _USERGBPOINTS1 . ':</td>
            <td width="59%">
              <input type="text" name="xpoints1" size="12" value="' . $points1 . '" />
            </td>
          </tr>
          <tr>
            <td width="41%">' . _USERGBPOINTS2 . ':</td>
            <td width="59%">
              <input type="text" name="xpoints2" size="12" value="' . $points2 . '" />
            </td>
          </tr>

          <tr>
            <td width="100%" colspan="2">&nbsp;</td>
          </tr>
          <tr>
            <td width="100%" colspan="2">
              <input type="hidden" name="op" value="' . PMX_MODULE . '/configsave" />
              <input type="submit" value="' . _USERGBSAVESETTINGS . '" />
            </td>
          </tr>

        </table>
      </form>
    </fieldset>';
    CloseTable();
    include('footer.php');
}

switch ($op) {
    case PMX_MODULE . '/configsave':
        usergbconfigsave();
        break;
    default :
        usergbsettings();
        break;
}

?>