<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Ausgabe scrollen? false = nein, true = ja */
$scrolling = true;

/* Anzahl der Weblinksueberschriften, die angezeigt werden sollen */
$numartikel = 10;

/* Hoehe des Ausgabebereichs beim Scrollen */
$hoehe = 100;

/* Geschwindigkeit fuer das Scrollen
 * Wertebereich 1 - 100 */
$scrollspeed = 4;

/* Scrollrichtung
 * up = aufwaerts
 * down = abwaerts
 * left = von rechts nach links
 * right = von links nach rechts */
$scrolldirection = 'up';

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

global $prefix;

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

/* Block kann gecached werden? */
$mxblockcache = true;

$show = '';
$result = sql_query("SELECT lid, title, hits FROM " . $prefix . "_links_links ORDER BY hits DESC LIMIT " . intval($numartikel));
while (list($lid, $title, $hits) = sql_fetch_row($result)) {
    if (!trim($title)) {
        continue;
    }
    $show .= '<li><a href="modules.php?name=' . $module_name . '&amp;op=view&amp;lid=' . $lid . '">' . trim($title) . '</a><br /><span class="tiny">(Visits: ' . mxValueToString($hits, 0) . ' x)</span></li>';
}
if ($show) {
    $show = '<ul class="list">' . $show . '</ul>';
    if ($scrolling) {
        $content = mxScrollContent($show, $scrolldirection, $scrollspeed, $hoehe);
    } else {
        $content = $show;
    }
}

?>