<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

function RandomLink()
{
    global $prefix, $module_name, $pagetitle;
    global $perpage;
    // Anzahl begrenzen
    $limit = ($perpage > 20) ? 20 : intval($perpage);
    if (!$limit) {
        $limit = 5;
    }
    // die aktuelle Kategorie-id aus request ermitteln, wenn leer, dann ist es die Hauptseite ohne spezielle Kategorie
    $cid = (empty($_REQUEST['cid']) || $_REQUEST['cid'] < 0) ? 0 : intval($_REQUEST['cid']);
    // diese als Bedingung verwenden, falls vorhanden
    $cid_where = ($cid) ? ' AND dd.cid=' . $cid : '';
    $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.linkid AS editorialid
            FROM " . $prefix . "_links_links AS dd
            LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
            WHERE dd.cid > 0
            " . $cid_where . "
            ORDER BY RAND()
            LIMIT " . $limit;
    $result = sql_query($qry);
    $rows = array();
    while ($x = sql_fetch_assoc($result)) {
        $rows[] = $x;
    }

    $totalrows = @count($rows);
    // Daten fuer header aufbereiten
    $title = $totalrows . '&nbsp;' . _RANDOMITEMS;
    $pagetitle = strip_tags($title);
    // die Ausgabe
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    if ($totalrows) {
        OpenTable();
        foreach($rows as $row) {
            modViewData($row, 'list');
        }
        CloseTable();
        echo '<br />';
    } else {
        OpenTable();
        echo '<div align="center" class="content">' . _NOTHINGINVIEW . '<br /><br />' . _GOBACK . '<br /><br /><br /><br /><br /><br /><br /><br /></div>';
        CloseTable();
        echo '<br />';
    }
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

function getRandomLinkId($counter)
{
    global $prefix;
    // die aktuelle Kategorie-id aus request ermitteln, wenn leer, dann ist es die Hauptseite ohne spezielle Kategorie
    $cid = (empty($_REQUEST['cid']) || $_REQUEST['cid'] < 0) ? 0 : intval($_REQUEST['cid']);

    /*
    // evtl. angegebene Kategorien beachten
    if ($cid) {
        // Kategorie angegeben
        $qry = "SELECT cid, captcha FROM " . $prefix . "_links_categories WHERE NOT captcha AND cid=".$cid;
        $result = sql_query($qry);
        $row = sql_fetch_assoc($result);
        if (empty($row['cid'])) {
            // Captchas in dieser Kategorie, oder Kategorie nicht gefunden
            //  - aus allen Kategorien ohne Captchas waehlen
            $cid_where = 'WHERE NOT dc.captcha';
        } else {
            // Kategorie gefunden und keine Captchas in dieser Kategorie
            //  - nur aus dieser Kategorie waehlen
            $cid_where = 'WHERE dd.cid='.$cid;
        }
    } else {
        // Kategorie nicht angegeben, oder Hauptkategorie 0
        //  - aus allen Kategorien ohne Captchas waehlen
        $cid_where = 'WHERE NOT dc.captcha';
    }
     */
    // Anzahl aller Links mit dieser Bedingung ermitteln
    $qry = "SELECT COUNT(dd.lid) AS cnt
        FROM " . $prefix . "_links_links AS dd
        LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid " . $cid_where;
    $result = sql_query($qry);
    list($cnt) = sql_fetch_row($result);
    // wenn kein entsprechender Link vorhanden, eine leere $lid zurueckgeben, damit eine Fehlermeldung generiert wird
    if (empty($cnt)) {
        return 0;
    }
    // Aus der gegebenen Anzahl eine Zufallszahl in diesem Bereich ermitteln
    mt_srand((double)microtime() * 1000000);
    $rnd = (mt_rand(1, $cnt)-1);
    // diese Zufallszahl als Startwert fuer LIMIT verwenden
    $qry = "SELECT dd.lid
        FROM " . $prefix . "_links_links AS dd
        LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid " . $cid_where . "
        LIMIT " . $rnd . ", 1";
    $result = sql_query($qry);
    list($lid) = sql_fetch_row($result);
    // die zufaellige $lid zurueckgeben
    return intval($lid);
}

?>