/**
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 * $Id: jquery.theme.js 499 2022-05-11 12:15:10Z PragmaMx $
 */

if (isIE == 'undefined') var isIE = false;
if (isIE6 == 'undefined') var isIE6 = false;

// init
$(document).ready(function ($) {
  if (isIE6) {
    $('#page').prepend("<div class='crap-browser-warning'>You're using a old and buggy browser. Switch to a <a href='http://www.mozilla.com/firefox/'>normal browser</a> or consider <a href='http://www.microsoft.com/windows/internet-explorer'>upgrading your Internet Explorer</a> to the latest version</div>");
  }
  $('#navbar').superfish({
    autoArrows: true
  });

  // fade effect
  if (!isIE) {
    $('.fadethis').append('<span class="hover"></span>').each(function () {
      var jQueryspan = $('> span.hover', this).css('opacity', 0);
      $(this).hover(function () {
        jQueryspan.stop().fadeTo(333, 1);
      }, function () {
        jQueryspan.stop().fadeTo(333, 0);
      });
    });
  }

  // scroll to top
  $('#back-top').click(function () {
    $('html,body,document').animate({
      scrollTop: 0
    }, 'slow');
    return false;
  });

  // Login & Logout
  $(".account input").focus(function () {
    var el = $(this);
    if (this.name == 'password' && el.attr("type") != 'password') {
      var el2 = $('<input/>').attr("type", "password").attr("name", "pass").attr("title", this.title);
      el.after(el2);
      el.remove();
      el2.focus();
    } else if (this.name == 'uname' && this.value == this.title) {
      this.value = '';
    }
    this.select();
  }).blur(function () {
    if (!this.value) {
      this.value = this.title;
    }
  });
  $(".account button[type='reset']").click(function () {
    closeAcc();
    return false;
  });
  $("#topmenu .acc a").each(function () {
    $(this).removeAttr("href").css("cursor", "pointer");
  });

  // toggle login / logout
  $("#topmenu .acc").each(function (i) {
    var a = $(this);
    var id = a.attr("id");
    a.mouseover(function () {
      a.addClass("active");
    });
    a.tooltip({
      tip: (id == 'topmenulogin') ? '#theme-login' : '#theme-logout',
      position: 'bottom right',
      offset: [-1, -a.outerWidth()],
      events: {
        tooltip: 'mouseover'
      },
      onShow: function (e) {
        a.addClass("active");
        $((id != 'topmenulogin') ? '#theme-login' : '#theme-logout').hide();
      },
      onBeforeHide: function (e, i) {
        a.removeClass("active");
      }
    });
  });
  function closeAcc() {
    var panel = $("#topmenu .active").data("tooltip");
    if (panel) {
      panel.hide();
    }
    $("#topmenu .acc").removeClass("active");
  }
  $(document).click(function (e) {
    var el = $(e.target)
    if ($(".account:visible").length && !el.is(".account") && !el.parents(".account").length && !el.is("#topmenu .acc")) {
      closeAcc();
    }
  });
  $(document).keydown(function (e) {
    if (e.keyCode == 27) {
      closeAcc();
    }
  });

//  if (!isIE7) {
//    // fade in #back-top
//    $("#back-top").hide();
//    $(window).scroll(function () {
//      if ($(this).scrollTop() > 100) {
//        $('#back-top').fadeIn();
//      } else {
//        $('#back-top').fadeOut();
//      }
//    });
//  }

  // set accessibility roles on some elements trough js (to not break the xhtml markup)
  $("#navbar").attr("role", "navigation");
  $("#mainbar").attr("role", "main");
  $("#sidebar-right").attr("role", "complementary");
  $("#searchform").attr("role", "search");
  // Suchformular einblenden
  $("#searchform").show();
});

$(window).load(function() {
  $("#bottom .block-inside").height( $("#bottom .menubar").innerHeight() );
});