<?php

/**

 * pragmaMx - Web Content Management System.

 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org

 * $Id: layout.fixed.css.php 499 2022-05-11 12:15:10Z PragmaMx $

 */



define('mxMainFileLoaded', 1);



/* CSS Header senden */

header('Content-Type: text/css');

header('X-Powered-By: pragmaMx-cms');

header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 3600 * 24) . ' GMT'); // 1 day

header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime('../theme.settings.php')) . ' GMT');

header('Etag: ' . md5(filemtime('../theme.settings.php')));



/* default widths - fixed - 960gs  */

$defaults = array(/* Breiten */

    'page' => 960,

    'left' => 204,

    'right' => 204,

    );



error_reporting(0);

include('../theme.settings.php');

error_reporting(E_ALL);

// Einstellungen aus settings.php in Zahlenwert konvertieren

$widths = array_map('floatval', $themesetting['layoutwidth']['fixed']);

// leere Werte aus settings.php entfernen

$widths = array_filter($widths);

// �brige korrigierte Werte aus settings.php �berschreiben Standardwerte

$widths = array_merge($defaults, $widths);

extract($widths, EXTR_OVERWRITE);



if ($left > $page / 2) {

    $left = $defaults['left'];

}

if ($right > $page / 2) {

    $right = $defaults['right'];

}



/* Padding abh�ngig von Gesamt-Breite berechnen */

$colpadding = intval($page / 100 * 1.2);



ob_start();



?>

<style>

<!--

<?php ob_end_clean(); ob_start(); ?>



/* Breiten und Position der Layoutspalten */



#sidebar-left {

	width: <?php echo $left ?>px;

}



#sidebar-right {

	width: <?php echo $right ?>px;

}



.page {

	width: <?php echo $page ?>px;

}



.col-1 #mainbar {

	left: 0;

	width: <?php echo $page ?>px;

}



.col-1 #sidebar-right,

.col-1 #sidebar-left {

	display: none;

}



.col-1 .block .block.__BLOCK_ID__ {

<?php /* z.B. Blockvorschau im Adminmenue */ ?>

	width: <?php echo $left ?>px;

}



.col-2-left #mainbar {

	left: <?php echo $left ?>px;

	width: <?php echo $page - $left ?>px;

}



.col-2-left #sidebar-left {

	display: block;

	right: <?php echo $page - $left ?>px;

}



.col-2-left #sidebar-right {

	display: none;

}



.col-2-left.col-to-right #mainbar {

	left: 0;

}



.col-2-left.col-to-right #sidebar-left {

	right: 0;

}



.col-2-right #mainbar {

	left: 0;

	width: <?php echo $page - $right ?>px;

}



.col-2-right #sidebar-left {

	display: none;

}



.col-2-right #sidebar-right {

	right: 0;

}



.col-2-right.col-to-left #mainbar {

	left: <?php echo $right ?>px;

}



.col-2-right.col-to-left #sidebar-right {

	right: <?php echo $page - $right ?>px;

}



.col-3 #mainbar {

	left: <?php echo $left ?>px;

}



.col-3 #mainbar,

.col-3-left #mainbar,

.col-3-right #mainbar {

	width: <?php echo $page - $left - $right ?>px;

}



.col-3 #sidebar-left,

.col-3-left #sidebar-right,

.col-3-left #sidebar-left {

	left: -<?php echo $page - $left - $right ?>px;

}



.col-3 #sidebar-right {

	right: 0;

}



.col-3-left #mainbar {

	left: <?php echo $left + $right ?>px;

}



.col-3-right #mainbar {

	left: 0;

}



.col-3-right #sidebar-left {

	left: <?php echo $right ?>px;

}



.col-3-right #sidebar-right {

	left: -<?php echo $left ?>px;

}



/* Margins der Layoutspalten */



#sidebar-left-inside {

	padding-right: <?php echo $colpadding ?>px;

	padding-left: <?php echo $colpadding ?>px;

}



#sidebar-right-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



#mainbar-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



.col-1 #mainbar-inside {

	padding-left: 0;

	padding-right: 0;

}



.col-2-left #mainbar-inside {

	/*padding-right: 0;*/

}



.col-2-left.col-to-right #mainbar-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



.col-2-left.col-to-right #sidebar-left-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



.col-2-right.col-to-left #sidebar-right-inside {

	padding-left: 0;

	padding-right: <?php echo $colpadding ?>px;

}



.col-3-left #mainbar-inside {

	padding-right: <?php echo $colpadding ?>px;

}



.col-3-left #sidebar-left-inside {

	padding-right: <?php echo $colpadding ?>px;

}



.col-3-left #sidebar-right-inside {

	padding-left: 0;

	padding-right: <?php echo $colpadding ?>px;

}



.col-3-right #mainbar-inside {

	padding-left: <?php echo $colpadding ?>px;

}



.col-3-right #sidebar-left-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



.col-3-right #sidebar-right-inside {

	padding-left: <?php echo $colpadding ?>px;

}





/* Position der vertikalen Linie zwischen den Layoutspalten */



.col-1 #main,

.col-1 #main-inside,

.col-2-right #main-inside,

.col-2-left #main-inside,

.col-3-right #main-inside,

.col-3-left #main-inside {

	background-image: none;

}



.col-3 #main,

.col-2-left #main {

	background-position: <?php echo $left ?>px;

}



.col-3 #main-inside {

	background-position: <?php echo $page - $right ?>px;

}



.col-3-left #main {

	background-position: <?php echo $left + $right ?>px;

}



.col-3-right #main {

	background-position: <?php echo $page - $right - $left ?>px;

}



.col-2-left.col-to-right #main {

	background-position: <?php echo $page - $left ?>px;

}



.col-2-right.col-to-left #main {

	background-position: <?php echo $right ?>px;

}



/* Untere rechte Bl�cke */



#bottom .page {

	width: <?php echo $page + (2*$colpadding) ?>px;

}



#bottom .block-inside {

	padding-left: <?php echo $colpadding ?>px;

	padding-right: <?php echo $colpadding ?>px;

}



<?php

$out = ob_get_clean();

$out = preg_replace('#/\*.+\*/#', ' ', $out);

$out = preg_replace('#\s+#', ' ', $out);

$out = preg_replace('#\s*([{:;,}])\s*#', '$1', $out);

$out = trim(str_replace('}', "}\n", $out));

die($out);

?>

-->

</style>

